//init global variables
var futureImages;
var run = true;
var isFading = false;

//array used to pre-cache the slideshow images
var slideCache = new Array();

//function changes Opacity of the object "id" to "opacity"
function changeOpac(opacity, id)
{
	//get object
	var object = document.getElementById(id).style;
	//set opacity for each attribute (different browser standards)
	object.opacity = (opacity / 100);
	object.MozOpacity = (opacity / 100);
	object.KhtmlOpacity = (opacity / 100);
	object.filter = "alpha(opacity=" + opacity + ")";
	//if opacity is bigger or equal 100 the fading is done
	if(opacity >= 100){
		isFading = false;
	}
}

//function shows the previous Picture
function showPrevPicture(){
	//stop the auto fading
	run=false;
	//if the image is not already fading
	if(!isFading) {
		//lock fading status
		isFading=true;
		//calculate ImageString shifts
		//select last position of ";"
		var imageSeparator = futureImages.substring(0,futureImages.length-1).lastIndexOf(";");
		//store the last image string to prevImage
		var prevImage = futureImages.substring(imageSeparator+1,futureImages.length-1);
		//select 2nd last positon of ";"
		var imageSeparator2 = futureImages.substring(0,imageSeparator-1).lastIndexOf(";");
		//store 2nd last image string to prevImage2 
		var prevImage2 = futureImages.substring(imageSeparator2+1,imageSeparator);
		//create new futureImages string with re-ordered Images
		futureImages = prevImage + ';' + futureImages.substring(0, imageSeparator) + ';';
		//blend current image and previous image
		blendimage("PictureFrame","PictureDisplay",prevImage2,20);
	}
}

//function shows the next Picture
function showNextPicture(){
	//stop the auto fading
	run=false;
	//if the image is not already fading
	if(!isFading) {
		//lock fading status
		isFading=true;
		//calculate ImageString shifts
		//select first position of ";"
		var imageSeparator = futureImages.indexOf(";");
		//store first image string in nextImage
		var nextImage = futureImages.substring(0,imageSeparator);
		//create new futureImages string with re-ordered Images
		futureImages = futureImages.substring(imageSeparator+1, futureImages.length) + nextImage + ';';
		//blend current image and next image
		blendimage("PictureFrame","PictureDisplay",nextImage,20);
	}
	
}

//function blends new image "imagefile" in "millisec" using the the div "divid" and the image "imageid"
function blendimage(divid, imageid, imagefile, millisec)
{
	//help variables
	var speed = Math.round(millisec / 3);
	var timer = 0;
	
	//script in progress
	run = true;
	
	//set the current image as background
	//var nextPicture = document.getElementById(imageid).src;
	//nextPicture = 'url("'+nextPicture.substring(nextPicture.indexOf("includes/slideshowthumb.php"))+'")';
	//document.getElementById(divid).style.backgroundImage = nextPicture;
	document.getElementById(divid).style.backgroundImage = 'url("'+document.getElementById(imageid).src+'")';

	//make image transparent
	changeOpac(0, imageid);
	
	//set new image
	document.getElementById(imageid).src = imagefile;
	
	//fade image
	isFading = true;
	for(i = 0; i <= 100; i++)
	{
		if (run == true){
			setTimeout("changeOpac(" + i + ",'"+imageid+"')", (timer * speed));
			timer++;
		} else {
			isFading = false;
			break;
		}
	}
}

//function automatically fades images after "displaySecs" seconds
function RunSlideShow(divid,imageid,displaySecs)
{
	//if slideshow is enabled
	if (run == true){
		//select 1st position of ";"
		var imageSeparator = futureImages.indexOf(";");
		//select 1st image string
		var nextImage = futureImages.substring(0,imageSeparator);
		//make image transparent
		changeOpac(0, imageid);
		//start blending
		blendimage(divid,imageid,nextImage,100);
		//create new futureImages string with re-ordered Images
		futureImages = futureImages.substring(imageSeparator+1, futureImages.length) + nextImage + ';';
		//recall function with next image in "displaySecs" seconds
		setTimeout("RunSlideShow('"+divid+"','"+imageid+"',"+displaySecs+")", displaySecs*1000);
		
		//cache the next image to improve performance.
		imageSeparator = futureImages.indexOf(";");
		nextImage = futureImages.substring(0,imageSeparator);
		if (slideCache[nextImage] == null)
		{
			slideCache[nextImage] = new Image;
			slideCache[nextImage].src = nextImage;
		}	
	}
}