function getCssStyle(var_div, var_cssStyleName)
{
	var element = document.getElementById(var_div);
	if (element.currentStyle)
		var style = element.currentStyle[var_cssStyleName];
	else if (window.getComputedStyle)
		var style = document.defaultView.getComputedStyle(element,null).getPropertyValue(var_cssStyleName);
	return style;
}


function addOnClickEventsToTag(var_tagName, var_functionName){
	
	var divElements = document.getElementsByTagName(var_tagName);
	for (div in divElements) {
		if (divElements[div]){
			if (divElements[div].addEventListener){  
				divElements[div].addEventListener('click', var_functionName, false);   
			} else if (divElements[div].attachEvent){  
				divElements[div].attachEvent('onclick', var_functionName);  
			}  
		}
	}
	
}

function addOnClickEventsToClass(var_className, var_functionName){
	
	var divElements = getElementsByClass(var_className);
	for (div in divElements) {
		if (divElements[div]){
			if (divElements[div].addEventListener){  
				divElements[div].addEventListener('click', var_functionName, false);   
			} else if (divElements[div].attachEvent){  
				divElements[div].attachEvent('onclick', var_functionName);  
			}  
		}
	}
	
}

function getElementsByClass(searchClass,node,tag) {
	var classElements = new Array();
	if ( node == null )
		node = document;
	if ( tag == null )
		tag = '*';
	var els = node.getElementsByTagName(tag);
	var elsLen = els.length;
	var pattern = new RegExp("(^|\\s)"+searchClass+"(\\s|$)");
	for (i = 0, j = 0; i < elsLen; i++) {
		if ( pattern.test(els[i].className) ) {
			classElements[j] = els[i];
			j++;
		}
	}
	return classElements;
}

function error(var_errorString){
	if (GLOBAL_errorReporting == true) {
		try {
			page_error(var_errorString);
		} catch(err){
			alert("Error: \n"+var_errorString);
		}
	}
}

function debug(var_debugString){
	if (GLOBAL_debugReporting == true) {
		try {
			page_debug(var_errorString);
		} catch(err){
			alert("Debug: \n"+var_errorString);
		}
	}
}

// extract Homematic serialnumber from string
function stringToSn(var_string){
	var startpos = var_string.indexOf('_');
	if (startpos >-1){
		return (var_string.substring(startpos+1, var_string.length)).replace(/_/g, ":");
	} else {
		return false;		
	}
}

//calculates the present time and date
function presentTimeDate () {
	var TimeString, DateString;
	Now = new Date();
	//aktuelle Uhrzeit
	Hours = Now.getHours();
	Minutes = Now.getMinutes();
	TimeString = ((Hours < 10) ? "0" : "") + Hours;
	TimeString += ((Minutes < 10) ? ":0" : ":") + Minutes;
	TimeString += " Uhr";
	//aktuelles Datum
	Day= Now.getDate();
	Month= Now.getMonth()+1;
	Year= Now.getYear();

	// Probleme mit 2-stelligen Jahreszahlen in einigen Browsern umgehen
	if ((Year > 99) && (Year < 1900)) Year += 1900;

	DateString= ((Day < 10) ? "0" : "") + Day;
	DateString+= ((Month < 10) ? ".0" : ".") + Month;
	DateString+= "." + Year;
	
	var TimeContainer = document.getElementById("Status_Label");
	if (TimeContainer != null) {
		TimeContainer.innerHTML = DateString+"<br>"+TimeString;				
	}
	
	setTimeout("presentTimeDate()",5000);
}

//change statusLED image to var_status state
function updateLed(var_status){
	var element = document.getElementById("Status_LED");
	if (element != null){
		if((var_status == "") || (var_status == "clear") || (var_status == "blank") || (var_status == "none")){
			element.style.backgroundImage = "none";
		} else if (var_status == "green") {
			element.style.backgroundImage = "url(pictures/led_green.png)";
		} else if (var_status == "red") {
			element.style.backgroundImage = "url(pictures/led_red.png)";
		} else if (var_status == "blue") {
			element.style.backgroundImage = "url(pictures/led_blue.png)";
		} else if (var_status == "yellow") {
			element.style.backgroundImage = "url(pictures/led_yellow.png)";
		} else if (var_status == "black") {
			element.style.backgroundImage = "url(pictures/led_black.png)";
		} else if (var_status == "white") {
			element.style.backgroundImage = "url(pictures/led_white.png)";
		}
	}
}

function SecondsToTimeString(var_int){
	var hours = parseInt(var_int/3600);
	var seconds = parseInt(var_int%60);
	var minutes = parseInt((var_int - (hours*3600) - seconds)/60);
	return hours +":"+ (minutes<10 ? "0"+minutes : minutes) +":"+ (seconds<10 ? "0"+seconds : seconds);
}

function include_once(src) {
  // hole alle vorhandenen Script-Elemente
  var scripts = document.getElementsByTagName('script');
  if(scripts) {
    for(var k=0; k<scripts.length; k++) {
      // script schon geladen, abbrechen
      if(scripts[k].src == src) {
        return;
      }
    }
  }
  // script noch nicht geladen, binde es ein
  var script = document.createElement('script');
  script.src = src;
  script.type = 'text/javascript';
  (document.getElementsByTagName('HEAD')[0] || document.body).appendChild(script);
}