// -------------------------------------------------------------------------------
// HEADER BEGIN ------------------------------------------------------------------
// -------------------------------------------------------------------------------
//include_once("includes/globals.inc.js");
//include_once("includes/js/prototype.js");
//include_once("includes/js/ajax.js");
//include_once("includes/js/functions.js");
//include_once("includes/js/phpSession_functions.js");
// -------------------------------------------------------------------------------
// HEADER END --------------------------------------------------------------------
// -------------------------------------------------------------------------------


// SITE_devicesArray and GLOBAL_statusArray are needed.
function site_updateControls(){
	
	var device_status = null;
	var device_container = null;
	var device_divElement = null;
	var device_sn = null;
	var device_typ = null;
	var device_interface = null;
	
	for (device_id in SITE_devicesArray){
		device_sn = SITE_devicesArray[device_id]['SN'];
		device_typ = SITE_devicesArray[device_id]['TYP'];
		device_interface = SITE_devicesArray[device_id]['INTERFACE'];
		device_container = SITE_devicesArray[device_id]['HTML_CONTAINER'];
		device_divElement = document.getElementById(device_container);
		
		switch(device_interface.toUpperCase()){
			case 'HSS':
			case 'REGA-HSS':
			case 'REGA':
			case 'REGAHSS':
			case 'CCU':
				// RegaHSS device
				if (GLOBAL_regaHssArray[device_id] == null){
					continue;
				}
				break;
	
			default:
				//XMLRPC device
				if (GLOBAL_statusArray[device_sn] == null) {
					continue;
				}
				break;
		}
		
		
		switch(device_typ){
			case 'VALUE':
				var datapoint = SITE_devicesArray[device_id]['DATAPOINT'];
				if(datapoint != null && datapoint != '') {
					device_status = GLOBAL_statusArray[device_sn][datapoint];
					if (device_status != null) device_divElement.innerHTML = device_status;
				} else {
					error("site_updateControls(): VALUE needs DATAPOINT (ID: "+device_id+")");
				}
				break;
				
			case 'SWITCH':
				device_status = GLOBAL_statusArray[device_sn]['STATE'];
				if (device_status == "true"){
					// Schalter an
					device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureOn+')';
					device_divElement.onclick = new Function('xmlRpc_setDeviceState("'+device_interface+'", "'+device_sn+'", "false");');
				} else if (device_status == "false"){
					// Schalter aus
					device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureOff+')';
					device_divElement.onclick = new Function('xmlRpc_setDeviceState("'+device_interface+'", "'+device_sn+'", "true");');
				}
				break;
			
			case 'SWITCH_TEXT':
				device_status = GLOBAL_statusArray[device_sn]['STATE'];
				if (device_status == "true"){
					// Schalter an
					device_divElement.innerHTML = GLOBAL_textOn;
					device_divElement.onclick = new Function('xmlRpc_setDeviceState("'+device_interface+'", "'+device_sn+'", "false");');
				} else if (device_status == "false"){
					// Schalter aus
					device_divElement.innerHTML = GLOBAL_textOff;
					device_divElement.onclick = new Function('xmlRpc_setDeviceState("'+device_interface+'", "'+device_sn+'", "true");');
				}
				break;
			
			case 'DIMMER_SWITCH':
				device_status = GLOBAL_statusArray[device_sn]['LEVEL'];
				if( GLOBAL_statusArray[device_sn]['WORKING'] != "true" ){
					if (device_status <= 0.0){
						device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureOff+')';
						device_divElement.onclick = new Function('xmlRpc_setValueAction("'+device_interface+'", "'+device_sn+'", "OLD_LEVEL");');
					} else if (device_status > 0.0){
						device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureOn+')';
						device_divElement.onclick = new Function('xmlRpc_setDeviceLevel("'+device_interface+'", "'+device_sn+'", "0.0");');
					}
				}
				break;
				
			case 'DIMMER_SWITCH_DISABLED':
				device_status = GLOBAL_statusArray[device_sn]['LEVEL'];
				if( GLOBAL_statusArray[device_sn]['WORKING'] != "true" ){
					if (device_status <= 0.0){
						device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureOff+')';
					} else if (device_status > 0.0){
						device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureOn+')';
					}
				}
				break;
				
			case 'DIMMER_TEXT':
			case 'BLIND_TEXT':
			case 'LEVEL_TEXT':
				if (GLOBAL_statusArray[device_sn]['LEVEL'] != null) device_divElement.innerHTML = (parseFloat(GLOBAL_statusArray[device_sn]['LEVEL'])*100).toString()+" %";
				break;
				
			case 'WINMATIC_ICON':
				device_status = GLOBAL_statusArray[device_sn]['LEVEL'];
				if (device_status != null){
					if (device_status == '-0.005'){
						device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureLocked+')';
					} else if (device_status == '0.0') {
						device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureClosed+')';
					} else {
						device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureOpen+')';
					}
				}
				break;
				
			case 'WINMATIC_TEXT':
				device_status = GLOBAL_statusArray[device_sn]['LEVEL'];
				if (device_status != null){
					if (device_status == '-0.005'){
						device_divElement.innerHTML = GLOBAL_textLocked;
					} else if (device_status == '0.0') {
						device_divElement.innerHTML = GLOBAL_textClosed;
					} else {
						device_divElement.innerHTML = GLOBAL_textOpen;
					}
				}
				break;
				
			case 'WINMATIC_TEXT_PERCENT':
				device_status = GLOBAL_statusArray[device_sn]['LEVEL'];
				if (device_status != null){
					if (device_status == '-0.005'){
						device_divElement.innerHTML = GLOBAL_textLocked;
					} else {
						device_divElement.innerHTML = (parseFloat(GLOBAL_statusArray[device_sn]['LEVEL'])*100).toString()+" %";
					}
				}
				break;
				
			case 'VALVE_STATE_TEXT':
				device_status = GLOBAL_statusArray[device_sn]['VALVE_STATE'];
				if (device_status != null) device_divElement.innerHTML = device_status+" %";
				break;
				
			case 'VALVE_STATE_ICON':
				device_status = GLOBAL_statusArray[device_sn]['VALVE_STATE'].toString();
				if (device_status != null){
					if (device_status == '0'){
						device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureVentClosed+')';
					} else {
						device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureVentOpen+')';
					}
				}
				break;
				
			case 'DIMMER_SLIDER':
			case 'BLIND_SLIDER':
			case 'WINMATIC_SLIDER':
				if( (GLOBAL_SliderArray[device_container] != false) && (GLOBAL_statusArray[device_sn]['WORKING'] != "true") ){
					device_status = parseInt(parseFloat(GLOBAL_statusArray[device_sn]['LEVEL'])*100);
					jQuery('#'+device_container).slider("value",device_status);
				} 
				break;
								
			case 'DIMMER_SLIDER_INVERSE':
			case 'BLIND_SLIDER_INVERSE':
				if( (GLOBAL_SliderArray[device_container] != false) && (GLOBAL_statusArray[device_sn]['WORKING'] != "true") ){
					device_status = 100-parseInt(parseFloat(GLOBAL_statusArray[device_sn]['LEVEL'])*100);
					jQuery('#'+device_container).slider("value",device_status);
				} 
				break;
								
			case 'WORKING_ICON':
				device_status = GLOBAL_statusArray[device_sn]['WORKING'];
				if (device_status == "true"){
					// no contact
					device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureWorking+')';
				} else if (device_status == "false"){
					// contact
					device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureIdle+')';
				}
				break;
				
			case 'WORKING_TEXT':
				device_status = GLOBAL_statusArray[device_sn]['WORKING'];
				if (device_status == "true"){
					// no contact
					device_divElement.innerHTML = GLOBAL_textWorking;
				} else if (device_status == "false"){
					// contact
					device_divElement.innerHTML = GLOBAL_textIdle;
				}
				break;
				
			case 'KEYMATIC_STATE_ICON':
				device_status = GLOBAL_statusArray[device_sn]['STATE'];
				if (device_status == "true"){
					// no contact
					device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureUnlocked+')';
				} else if (device_status == "false"){
					// contact
					device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureLocked+')';
				}
				break;
				
			case 'KEYMATIC_STATE_TEXT':
				device_status = GLOBAL_statusArray[device_sn]['STATE'];
				if (device_status == "true"){
					// no contact
					device_divElement.innerHTML = GLOBAL_textUnlocked;
				} else if (device_status == "false"){
					// contact
					device_divElement.innerHTML = GLOBAL_textLocked;
				}
				break;
				
			case 'RAINING_ICON':
				device_status = GLOBAL_statusArray[device_sn]['RAINING'];
				if (device_status == "true"){
					// no contact
					device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureRaining+')';
				} else if (device_status == "false"){
					// contact
					device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureNotRaining+')';
				}
				break;
				
			case 'RAINING_TEXT':
				device_status = GLOBAL_statusArray[device_sn]['RAINING'];
				if (device_status == "true"){
					// no contact
					device_divElement.innerHTML = GLOBAL_textRaining;
				} else if (device_status == "false"){
					// contact
					device_divElement.innerHTML = GLOBAL_textNotRaining;
				}
				break;
				
			case 'CONTACT_ICON':
				device_status = GLOBAL_statusArray[device_sn]['STATE'];
				if (device_status == "true"){
					// no contact
					device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureOpen+')';
				} else if (device_status == "false"){
					// contact
					device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureClosed+')';
				}
				break;
				
			case 'CONTACT_TEXT':
				device_status = GLOBAL_statusArray[device_sn]['STATE'];
				if (device_status == "true"){
					// no contact
					device_divElement.innerHTML = GLOBAL_textOpen;
				} else if (device_status == "false"){
					// contact
					device_divElement.innerHTML = GLOBAL_textClosed;
				}
				break;
				
			case 'MOTION_ICON':
				device_status = GLOBAL_statusArray[device_sn]['MOTION'];
				if (device_status == "true"){
					// motion
					device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureMotion+')';
				} else if (device_status == "false"){
					// no motion
					device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureNoMotion+')';
				}
				break;
				
			case 'MOTION_TEXT':
				device_status = GLOBAL_statusArray[device_sn]['MOTION'];
				if (device_status == "true"){
					// motion
					device_divElement.innerHTML = GLOBAL_textMotion;
				} else if (device_status == "false"){
					// no motion
					device_divElement.innerHTML = GLOBAL_textNoMotion;
				}
				break;
				
			case 'BRIGHTNESS':
				device_status = GLOBAL_statusArray[device_sn]['BRIGHTNESS'];
				if (device_status != null) device_divElement.innerHTML = "Helligkeit: "+device_status;
				break;
				
			case 'SETPOINT':
				device_status = GLOBAL_statusArray[device_sn]['SETPOINT'].toString();
				if (device_status != null){
					if (device_status == '0.0'){
						device_divElement.innerHTML = GLOBAL_textVentClosed;
					} else if (device_status == '100.0'){
						device_divElement.innerHTML = GLOBAL_textVentOpen;
					} else {
						device_divElement.innerHTML = device_status+" &#176;C";
					}
				}
				break;
				
			case 'SETPOINT_ICON':
				device_status = GLOBAL_statusArray[device_sn]['SETPOINT'].toString();
				if (device_status != null){
					if (device_status == '0.0'){
						device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureVentClosed+')';
					} else if (device_status == '100.0'){
						device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureVentOpen+')';
					} else {
						device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureVentTemperatureControled+')';
					}
				}
				break;
				
			case 'RAIN_COUNTER':
				device_status = GLOBAL_statusArray[device_sn]['RAIN_COUNTER'];
				if (device_status != null) device_divElement.innerHTML = device_status+" mm";
				break;
				
			case 'WIND_SPEED':
				device_status = GLOBAL_statusArray[device_sn]['WIND_SPEED'];
				if (device_status != null) device_divElement.innerHTML = device_status+" km/h";
				break;
				
			case 'WIND_DIRECTION':
				device_status = GLOBAL_statusArray[device_sn]['WIND_DIRECTION'];
				if (device_status != null) device_divElement.innerHTML = device_status+" &#176;";
				break;
				
			case 'WIND_DIRECTION_RANGE':
				device_status = GLOBAL_statusArray[device_sn]['WIND_DIRECTION_RANGE'];
				if (device_status != null) device_divElement.innerHTML = device_status+" &#176;";
				break;
				
			case 'SUNSHINEDURATION':
				device_status = GLOBAL_statusArray[device_sn]['SUNSHINEDURATION'];
				if (device_status != null) device_divElement.innerHTML = device_status+" min";
				break;
				
			case 'AIR_PRESSURE':
				device_status = GLOBAL_statusArray[device_sn]['AIR_PRESSURE'];
				if (device_status != null) device_divElement.innerHTML = device_status+" hPa";
				break;
				
			case 'TEMPERATURE':
				device_status = GLOBAL_statusArray[device_sn]['TEMPERATURE'];
				if (device_status != null) device_divElement.innerHTML = device_status+" &#176;C";
				break;
				
			case 'HUMIDITY':
				device_status = GLOBAL_statusArray[device_sn]['HUMIDITY'];
				if (device_status != null) device_divElement.innerHTML = device_status+" %";
				break;
				
			case 'HISTORY_VALUE':
				var datapoint = SITE_devicesArray[device_id]['DATAPOINT'];
				var historyIndex = SITE_devicesArray[device_id]['HISTORY'];
				if ( (GLOBAL_statusArray[device_sn][datapoint+'_HISTORY'] != null) && GLOBAL_statusArray[device_sn][datapoint+'_HISTORY'][historyIndex] != null){
					device_status = GLOBAL_statusArray[device_sn][datapoint+'_HISTORY'][historyIndex]['VALUE'];
					if (device_status != null) device_divElement.innerHTML = device_status;
				}
				break;
				
			case 'HISTORY_TIME':
				var datapoint = SITE_devicesArray[device_id]['DATAPOINT'];
				var historyIndex = SITE_devicesArray[device_id]['HISTORY'];
				if ( (GLOBAL_statusArray[device_sn][datapoint+'_HISTORY'] != null) && GLOBAL_statusArray[device_sn][datapoint+'_HISTORY'][historyIndex] != null){
					device_status = GLOBAL_statusArray[device_sn][datapoint+'_HISTORY'][historyIndex]['TIME'];
					if (device_status != null) device_divElement.innerHTML = device_status;
				}
				break;
				
			case 'REGAHSS_VARIABLE_TEXT':
				device_status = GLOBAL_regaHssArray[device_id]['VARIABLE'];
				if (device_status != null) device_divElement.innerHTML = device_status;
				break;
				
			case 'REGAHSS_VARIABLE_STATE':
				device_status = GLOBAL_regaHssArray[device_id]['VARIABLE'];
				if ( (device_status == "1") || ( device_status.toLowerCase()== "true") ){
					// Schalter an
					device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureYes+')';
					device_divElement.onclick = new Function('regaHss_setSystemVariable("'+device_id+'", "0");');
				} else if ( (device_status == "0") || ( device_status.toLowerCase()== "false") ){
					// Schalter aus
					device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureNo+')';
					device_divElement.onclick = new Function('regaHss_setSystemVariable("'+device_id+'", "1");');
				}
				break;
				
			case 'REGAHSS_VARIABLE_STATE_IO':
				device_status = GLOBAL_regaHssArray[device_id]['VARIABLE'];
				if ( (device_status == "1") || ( device_status.toLowerCase()== "true") ){
					// Schalter an
					device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureOn+')';
					device_divElement.onclick = new Function('regaHss_setSystemVariable("'+device_id+'", "0");');
				} else if ( (device_status == "0") || ( device_status.toLowerCase()== "false") ){
					// Schalter aus
					device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureOff+')';
					device_divElement.onclick = new Function('regaHss_setSystemVariable("'+device_id+'", "1");');
				}
				break;
				
			case 'REGAHSS_VARIABLE_STATE_DISABLED':
				device_status = GLOBAL_regaHssArray[device_id]['VARIABLE'];
				if ( (device_status == "1") || ( device_status.toLowerCase()== "true") ){
					// Schalter an
					device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureYesDisabled+')';
				} else if ( (device_status == "0") || ( device_status.toLowerCase()== "false") ){
					// Schalter aus
					device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureNoDisabled+')';
				}
				break;
				
			case 'REGAHSS_PROGRAM':
			case 'STOP':
			case 'BLIND_STOP':
			case 'PRESS_LONG':
			case 'PRESS_SHORT':
			case 'PRESS':
				break;
				
			default:
				if (device_typ.toUpperCase().indexOf('CUSTOM') != -1){
					debug("Custom Typ");
				} else {
					error("site_updateControls(): Elementtype unknown ("+device_typ+")");
				}
				break;
				
		}
		try {page_IdIterator(device_id, device_interface, device_sn, device_container, device_typ);} catch(err){}
	}
	try {page_update();} catch(err){}
}

function site_initOnclickEvent(var_devicesArray){
	var device_status = '';
	var device_container = '';
	var device_divElement = '';
	var device_sn = '';
	var device_typ = '';
	var device_interface = '';

	for (device_id in var_devicesArray){
		device_sn = var_devicesArray[device_id]['SN'];
		device_typ = var_devicesArray[device_id]['TYP'];
		device_interface = var_devicesArray[device_id]['INTERFACE'];

		device_container = ''+var_devicesArray[device_id]['HTML_CONTAINER'];
		device_divElement = document.getElementById(device_container);
		
		switch(device_typ){
			case 'CONTACT':
			case 'CONTACT_ICON':
			case 'CONTACT_TEXT':
			case 'CONTACT_GET_VALUE':
			case 'SWITCH':
			case 'SWITCH_GET_VALUE':
			case 'SWITCH_TEXT':
			case 'KEYMATIC_STATE_ICON':
			case 'KEYMATIC_STATE_TEXT':
				device_divElement.onclick = new Function('xmlRpc_getValue("'+device_interface+'", "'+device_sn+'", "STATE");');
				break;
				
			case 'DIMMER_GET_VALUE':
			case 'DIMMER_SWITCH':
			case 'DIMMER_TEXT':
			case 'BLIND_TEXT':
			case 'WINMATIC_TEXT':
			case 'WINMATIC_ICON':
			case 'WINMATIC_TEXT_PERCENT':
			case 'LEVEL_TEXT':
				device_divElement.onclick = new Function('xmlRpc_getValue("'+device_interface+'", "'+device_sn+'", "LEVEL");');
				break;
				
			case 'VALVE_STATE_TEXT':
			case 'VALVE_STATE_ICON':
				device_divElement.onclick = new Function('xmlRpc_getValue("'+device_interface+'", "'+device_sn+'", "VALVE_STATE");');
				break;
				
			case 'WORKING_TEXT':
			case 'WORKING_ICON':
				device_divElement.onclick = new Function('xmlRpc_getValue("'+device_interface+'", "'+device_sn+'", "WORKING");');
				break;
				
			case 'STOP':
			case 'BLIND_STOP':
				device_divElement.onclick = new Function('xmlRpc_setValueAction("'+device_interface+'", "'+device_sn+'", "STOP");');
				break;
				
			case 'KEYMATIC_OPEN':
				device_divElement.onclick = new Function('xmlRpc_setValueAction("'+device_interface+'", "'+device_sn+'", "OPEN");');
				break;
				
			case 'PRESS':
				device_divElement.onclick = new Function('xmlRpc_setValueAction("'+device_interface+'", "'+device_sn+'", "PRESS");');
				break;
				
			case 'PRESS_LONG':
				device_divElement.onclick = new Function('xmlRpc_setValueAction("'+device_interface+'", "'+device_sn+'", "PRESS_LONG");');
				break;
				
			case 'PRESS_SHORT':
				device_divElement.onclick = new Function('xmlRpc_setValueAction("'+device_interface+'", "'+device_sn+'", "PRESS_SHORT");');
				break;
				
			case 'DIMMER_SLIDER':
			case 'BLIND_SLIDER':
			case 'WINMATIC_SLIDER':
				GLOBAL_SliderArray[device_container] = true;
				jQuery('#'+device_container).slider({
					range: STYLE_SLIDER_RANGE,
					animate: STYLE_SLIDER_ANIMATE,
					orientation: STYLE_SLIDER_ORIENTATION,
					value: STYLE_SLIDER_VALUE,
					step: STYLE_SLIDER_STEP,
					min: STYLE_SLIDER_MIN,
					max: STYLE_SLIDER_MAX,
					disabled: STYLE_SLIDER_DISABLED,
					start: new Function('event', 'ui', 'GLOBAL_SliderArray["'+device_container+'"] = false;'),
					change: new Function('event', 'ui', ''),
					slide: new Function('event', 'ui', ''),
					stop: new Function('event', 'ui', 'xmlRpc_setDeviceLevel("'+device_interface+'", "'+device_sn+'", (ui.value/100).toString()); GLOBAL_SliderArray["'+device_container+'"] = true;')
				});
				break;
				
			case 'DIMMER_SLIDER_INVERSE':
			case 'BLIND_SLIDER_INVERSE':
				GLOBAL_SliderArray[device_container] = true;
				jQuery('#'+device_container).slider({
					range: STYLE_SLIDER_RANGE,
					animate: STYLE_SLIDER_ANIMATE,
					orientation: STYLE_SLIDER_ORIENTATION,
					value: STYLE_SLIDER_VALUE,
					step: STYLE_SLIDER_STEP,
					min: STYLE_SLIDER_MIN,
					max: STYLE_SLIDER_MAX,
					disabled: STYLE_SLIDER_DISABLED,
					start: new Function('event', 'ui', 'GLOBAL_SliderArray["'+device_container+'"] = false;'),
					change: new Function('event', 'ui', ''),
					slide: new Function('event', 'ui', ''),
					stop: new Function('event', 'ui', 'xmlRpc_setDeviceLevel("'+device_interface+'", "'+device_sn+'", (1-(ui.value/100)).toString()); GLOBAL_SliderArray["'+device_container+'"] = true;')
				});
				break;
				
			case 'MOTION':
			case 'MOTION_ICON':
			case 'MOTION_TEXT':
			case 'MOTION_GET_VALUE':
				device_divElement.onclick = new Function('xmlRpc_getValue("'+device_interface+'", "'+device_sn+'", "MOTION");');
				break;
				
			case 'RAINING':
			case 'RAINING_GET_VALUE':
				device_divElement.onclick = new Function('xmlRpc_getValue("'+device_interface+'", "'+device_sn+'", "RAINING");');
				break;
				
			case 'RAIN_COUNTER':
			case 'RAIN_COUNTER_GET_VALUE':
				device_divElement.onclick = new Function('xmlRpc_getValue("'+device_interface+'", "'+device_sn+'", "RAIN_COUNTER");');
				break;
				
			case 'WIND_SPEED':
			case 'WIND_SPEED_GET_VALUE':
				device_divElement.onclick = new Function('xmlRpc_getValue("'+device_interface+'", "'+device_sn+'", "WIND_SPEED");');
				break;
				
			case 'WIND_DIRECTION':
			case 'WIND_DIRECTION_GET_VALUE':
				device_divElement.onclick = new Function('xmlRpc_getValue("'+device_interface+'", "'+device_sn+'", "WIND_DIRECTION");');
				break;
				
			case 'WIND_DIRECTION_RANGE':
			case 'WIND_DIRECTION_RANGE_GET_VALUE':
				device_divElement.onclick = new Function('xmlRpc_getValue("'+device_interface+'", "'+device_sn+'", "WIND_DIRECTION");');
				break;
				
			case 'SUNSHINEDURATION':
			case 'SUNSHINEDURATION_GET_VALUE':
				device_divElement.onclick = new Function('xmlRpc_getValue("'+device_interface+'", "'+device_sn+'", "WIND_DIRECTION");');
				break;
				
			case 'BRIGHTNESS':
			case 'BRIGHTNESS_GET_VALUE':
				device_divElement.onclick = new Function('xmlRpc_getValue("'+device_interface+'", "'+device_sn+'", "BRIGHTNESS");');
				break;
				
			case 'AIR_PRESSURE':
			case 'AIR_PRESSURE_GET_VALUE':
				device_divElement.onclick = new Function('xmlRpc_getValue("'+device_interface+'", "'+device_sn+'", "AIR_PRESSURE");');
				break;
				
			case 'TEMPERATURE':
			case 'TEMPERATURE_GET_VALUE':
				device_divElement.onclick = new Function('xmlRpc_getValue("'+device_interface+'", "'+device_sn+'", "TEMPERATURE");');
				break;
				
			case 'HUMIDITY':
			case 'HUMIDITY_GET_VALUE':
				device_divElement.onclick = new Function('xmlRpc_getValue("'+device_interface+'", "'+device_sn+'", "HUMIDITY");');
				break;

			case 'SETPOINT':
			case 'SETPOINT_ICON':
			case 'SETPOINT_GET_VALUE':
				device_divElement.onclick = new Function('xmlRpc_getValue("'+device_interface+'", "'+device_sn+'", "SETPOINT");');
				break;
				
			case 'GET_VALUE':
			case 'VALUE':
				var datapoint = var_devicesArray[device_id]['DATAPOINT'];
				if(datapoint == '' || datapoint == null) {
					error("site_initOnclickEvent(): GET_VALUE needs DATAPOINT");
				} else {
					device_divElement.onclick = new Function('xmlRpc_getValue("'+device_interface+'", "'+device_sn+'", "'+datapoint+'");');
				}
				break;
				
			case 'REGAHSS_PROGRAM':
				device_divElement.style.backgroundImage = 'url('+GLOBAL_pictureStart+')';
				device_divElement.onclick = new Function('regaHss_executeProgram("'+device_sn+'");');
				break;
				
			case 'REGAHSS_VARIABLE_STATE':
			case 'REGAHSS_VARIABLE_STATE_IO':
			case 'REGAHSS_VARIABLE_STATE_DISABLED':
				device_divElement.onclick = new Function("regaHss_RequestGlobalDeviceArray('var "+device_id+"_VARIABLE = dom.GetObject(\""+device_sn+"\").Variable();');");
				break;
				
			case 'HISTORY_TIME':
			case 'HISTORY_VALUE':
			case 'HISTORY2':
			case 'REGAHSS_VARIABLE_TEXT':
				break;
				
			default:
				if (device_typ.toUpperCase().indexOf('CUSTOM') != -1){
					try {page_customInitIterator(device_id, device_interface, device_sn, device_container, device_typ);} catch(err){}
					debug("Custom Typ");
				} else {
					error("site_initOnclickEvent(): Elementtype unknown ("+device_typ+")");
				}
				break;
				
		}
		
	}
}

function site_addClickedToClass(var_className){
	var divElements = getElementsByClass(var_className);
	for (div in divElements) {
		if (divElements[div]){
			if (divElements[div].addEventListener){  
				divElements[div].addEventListener('click', new Function('site_makeClicked("'+divElements[div].id+'")'), false);   
			} else if (divElements[div].attachEvent){  
				divElements[div].attachEvent('onclick', new Function('site_makeClicked("'+divElements[div].id+'")'));  
			}  
		}
	}
}


function site_makeClicked(var_div){
	if (var_div != null){
		var element = document.getElementById(var_div);
		var image = getCssStyle(var_div, 'background-image');
		if (image.indexOf('_down') == -1){
			var seperator = image.lastIndexOf('.');
			element.style.backgroundImage = image.substr(0, seperator)+'_down'+image.substr(seperator);
			setTimeout(function(){ element.style.backgroundImage = image; }, 100);
		}
	}
}

function site_makeClickedOn(var_div){
	if (var_div != null){
		var element = document.getElementById(var_div);
		var image = getCssStyle(var_div, 'background-image');
		if (image.indexOf('_down') == -1){
			var seperator = image.lastIndexOf('.');
			element.style.backgroundImage = image.substr(0, seperator)+'_down'+image.substr(seperator);
		}
	}
}
function site_makeClickedOff(var_div){
	if (var_div != null){
		var element = document.getElementById(var_div);
		var image = getCssStyle(var_div, 'background-image');
		if (image.indexOf('_down') != -1){
			var seperator = image.lastIndexOf('_down');
			element.style.backgroundImage = image.substr(0, seperator)+image.substr(seperator+5);
		}
	}
}