// send a command to the sonos.php page
function sonos_sendCommand(var_params){
	new Ajax.Request("../../includes/php/sonos.php", {method:"get", parameters:var_params});
}

function sonos_init(){
	new Ajax.Request("../../includes/php/sonos_init.php", {method:"get", parameters:"cmd=render"});
	new Ajax.Request("../../includes/php/sonos_init.php", {method:"get", parameters:"cmd=av"});
}

function sonos_getInfo(){
	updateLed("yellow");
	new Ajax.Request("../../includes/php/sonos.php", {
					 method:"get", 
					 parameters:"cmd=Info", 
					 onSuccess:function(transport){
						var responseArray = jsonParse(transport.responseText);
						sonos_prossesInfo(responseArray);
						updateLed("none");
					}});
}

function site_sonos_initMusicOnclickEvent(var_devicesArray){
	var state_status = '';
	var state_container = '';
	var state_divElement = '';
	var state_typ = '';

	for (state_id in var_devicesArray){
		state_typ = var_devicesArray[state_id]['TYP'];

		state_container = ''+var_devicesArray[state_id]['HTML_CONTAINER'];
		state_divElement = document.getElementById(state_container);
		
		switch(state_typ){
			case 'SONOS_REWIND':
				state_divElement.onclick = new Function('sonos_sendCommand("cmd=Rewind");');
				break;
			
			case 'SONOS_PREVIOUS':
				state_divElement.onclick = new Function('sonos_sendCommand("cmd=Previous");');
				break;
			
			case 'SONOS_STOP':
				state_divElement.onclick = new Function('sonos_sendCommand("cmd=Stop");');
				break;
			
			case 'SONOS_NEXT':
				state_divElement.onclick = new Function('sonos_sendCommand("cmd=Next");');
				break;
			
			case 'SONOS_VOLUME_SLIDER':
				GLOBAL_SliderArray[state_container] = true;
				jQuery('#'+state_container).slider({
					range: STYLE_SLIDER_RANGE,
					animate: STYLE_SLIDER_ANIMATE,
					orientation: STYLE_SLIDER_ORIENTATION,
					value: STYLE_SLIDER_VALUE,
					step: STYLE_SLIDER_STEP,
					min: STYLE_SLIDER_MIN,
					max: STYLE_SLIDER_MAX,
					disabled: STYLE_SLIDER_DISABLED,
					start: new Function('event', 'ui', 'GLOBAL_SliderArray["'+state_container+'"] = false;'),
					change: new Function('event', 'ui', ''),
					slide: new Function('event', 'ui', 'sonos_sendCommand("cmd=SetVolume&volume="+parseInt(ui.value).toString());'),
					stop: new Function('event', 'ui', 
									   'var temp_volume = parseInt(ui.value).toString();'+
									   'phpSession_setSonosValue("0", "Volume", temp_volume);'+
									   'sonos_sendCommand("cmd=SetVolume&volume="+temp_volume);'+
									   'GLOBAL_sonosArray["0"]["Volume"]["Master"] = temp_volume;'+
									   'GLOBAL_SliderArray["'+state_container+'"] = true;')
				});
				break;
				
			case 'SONOS_TEXT_ARTIST_TITLE':
			case 'SONOS_TEXT_NEXT_ARTIST_TITLE':
			case 'SONOS_TEXT_ALBUM':
			case 'SONOS_TEXT_NEXT_ALBUM':
			case 'SONOS_TEXT_POSITION':
			case 'SONOS_TEXT_DURATION':
			case 'SONOS_TEXT_NEXT_DURATION':
			case 'SONOS_PICTURE_ALBUM_ART':
			case 'SONOS_PICTURE_NEXT_ALBUM_ART':
			case 'SONOS_TEXT_TRANSPORT_TITLE':
			case 'SONOS_SOURCE_ICON':
			case 'SONOS_MUTE_TOGGLE':
			case 'SONOS_PLAY_PAUSE':
				break;
			
			default:
				debug("site_sonos_initMusicOnclickEvent(): statetype unknown ("+state_typ+")");
				break;
		}
	}
}


// SITE_statesArray and GLOBAL_sonosArray are needed.
function site_sonos_updateMusicSates(){
	var state_value = '';
	var state_value2 = '';
	var state_value3 = '';
	var state_container = '';
	var state_divElement = '';
	var state_typ = '';
	var TransportActions = 'Play';
	
	for (state_id in SITE_statesArray){
		state_typ = SITE_statesArray[state_id]['TYP'];
		state_container = ''+SITE_statesArray[state_id]['HTML_CONTAINER'];
		state_divElement = document.getElementById(state_container);
		
		
		if (GLOBAL_sonosArray["0"]["CurrentTransportActions"] != null) {
			TransportActions = GLOBAL_sonosArray["0"]["CurrentTransportActions"];
		}
		
		switch(state_typ){
			case 'SONOS_TEXT_ARTIST_TITLE':
				state_divElement.innerHTML = '';
				state_value = GLOBAL_sonosArray["0"]["CurrentTrackData"]["creator"];
				state_value2 = GLOBAL_sonosArray["0"]["CurrentTrackData"]["title"];
				state_value3 = GLOBAL_sonosArray["0"]["CurrentTrackData"]["streamContent"];
				if ((state_value != null) && (state_value2 != null)){
					if ((state_value != '') && (state_value2 != '')){
						state_divElement.innerHTML = state_value+' - '+state_value2;
					} else if ((state_value3 != '')){
						state_divElement.innerHTML = state_value3;
					} else if ((state_value != '')){
						state_divElement.innerHTML = state_value;
					} else if ((state_value2 != '')){
						state_divElement.innerHTML = state_value2;
					} else {
						state_divElement.innerHTML = '';
					}
				} else {
					state_divElement.innerHTML = '';
				}
				break;
				
			case 'SONOS_TEXT_NEXT_ARTIST_TITLE':
				state_value = GLOBAL_sonosArray["0"]["NextTrackData"]["creator"];
				state_value2 = GLOBAL_sonosArray["0"]["NextTrackData"]["title"];
				state_value3 = GLOBAL_sonosArray["0"]["NextTrackData"]["streamContent"];
				if ((state_value != null) && (state_value2 != null)){
					if ((state_value != '') && (state_value2 != '')){
						state_divElement.innerHTML = state_value+' - '+state_value2;
					} else if ((state_value3 != '')){
						state_divElement.innerHTML = state_value3;
					} else if ((state_value != '')){
						state_divElement.innerHTML = state_value;
					} else if ((state_value2 != '')){
						state_divElement.innerHTML = state_value2;
					} else {
						state_divElement.innerHTML = '';
					}
				} else {
					state_divElement.innerHTML = '';
				}
				break;
				
			case 'SONOS_TEXT_ALBUM':
				state_value = GLOBAL_sonosArray["0"]["CurrentTrackData"]["album"];
				if (state_value != null){
					state_divElement.innerHTML = state_value;
				} else {
					state_divElement.innerHTML = '';
				}
				break;
				
			case 'SONOS_TEXT_NEXT_ALBUM':
				state_value = GLOBAL_sonosArray["0"]["NextTrackData"]["album"];
				if (state_value != null){
					state_divElement.innerHTML = state_value;
				} else {
					state_divElement.innerHTML = '';
				}
				break;
				
			case 'SONOS_TEXT_POSITION':
				if (SITE_Duration != 0){
					state_divElement.innerHTML = SecondsToTimeString(SITE_Position) +' / '+ SecondsToTimeString(SITE_Duration);
				} else {
					state_divElement.innerHTML = SecondsToTimeString(SITE_Position);
				}
				break;
				
			case 'SONOS_TEXT_DURATION':
				state_value = GLOBAL_sonosArray["0"]["CurrentTrackData"]["Duration"];
				if (state_value != null){
					state_divElement.innerHTML = state_value;
				} else {
					state_divElement.innerHTML = '';
				}
				break;
				
			case 'SONOS_TEXT_NEXT_DURATION':
				state_value = GLOBAL_sonosArray["0"]["NextTrackData"]["Duration"];
				if (state_value != null){
					state_divElement.innerHTML = state_value;
				} else {
					state_divElement.innerHTML = '';
				}
				break;
				
			case 'SONOS_PICTURE_ALBUM_ART':
				state_value = GLOBAL_sonosArray["0"]["CurrentTrackData"]["albumArtURI"];
				if (state_value != null){
					
					if (state_value == ''){
						state_divElement.style.backgroundImage = 'none';
					} else if (state_value.indexOf('%2Fgetaa') == 0){
						state_divElement.style.backgroundImage = 'url(../../includes/php/thumb.php?src=http://'+GLOBAL_SONOS_IP+':'+GLOBAL_SONOS_PORT+state_value+'&p=174)';
					} else {
						state_divElement.style.backgroundImage = 'url(../../includes/php/thumb.php?src='+state_value+'&p=174)';
					}
				} else {
					state_divElement.style.backgroundImage = 'none';
				}
				break;
				
			case 'SONOS_PICTURE_NEXT_ALBUM_ART':
				state_value = GLOBAL_sonosArray["0"]["NextTrackData"]["albumArtURI"];
				if (state_value != null){
					if (state_value == ''){
						state_divElement.style.backgroundImage = 'none';
					} else if (state_value.indexOf('%2Fgetaa') == 0){
						state_divElement.style.backgroundImage = 'url(../../includes/php/thumb.php?src=http://'+GLOBAL_SONOS_IP+':'+GLOBAL_SONOS_PORT+state_value+'&p=174)';
					} else {
						state_divElement.style.backgroundImage = 'url(../../includes/php/thumb.php?src='+state_value+'&p=174)';
					}
				} else {
					state_divElement.style.backgroundImage = 'none';
				}
				break;
				
			case 'SONOS_TEXT_TRANSPORT_TITLE':
				state_value = GLOBAL_sonosArray["0"]["EnqueuedTransportURItitle"];
				if (state_value != null){
					if(state_value == ''){
						state_value2 = GLOBAL_sonosArray["0"]["CurrentTrackData"]["protocolInfo"];
						if (state_value2 != null){
							if (state_value2 == 'x-rincon-mp3radio:*:*:*'){
								state_divElement.innerHTML = 'MP3 Radio';
	
							} else if (state_value2 == 'last.fm-radio-http:*:audio/mpeg:*') {
								state_divElement.innerHTML = 'LastFM Radio';
								
							} else if (state_value2 == 'x-file-cifs:*:audio/mpeg:*') {
								state_divElement.innerHTML = 'Dateien';
								
							} else if (state_value2 == 'x-rincon-stream:*:*:*') {
								state_value3 = GLOBAL_sonosArray["0"]["CurrentTrackData"]["title"];
								if (state_value3 != null){
									state_divElement.innerHTML = state_value3;
								} else {
									state_divElement.innerHTML = 'Computer';
								}
							} else if (state_value2 == '') {
								state_divElement.innerHTML = '';
								
							} else {
								state_divElement.innerHTML = 'Sonstiges';
							}
						} else {
							state_divElement.innerHTML = '';
						}
						
					} else {
						state_divElement.innerHTML = state_value;
					}
				} else {
					state_divElement.innerHTML = '';
				}
				break;
				
			case 'SONOS_SOURCE_ICON':
				state_value = GLOBAL_sonosArray["0"]["CurrentTrackData"]["protocolInfo"];
				if (state_value != null){
					if (state_value == 'x-rincon-mp3radio:*:*:*'){
						state_divElement.style.backgroundImage = 'url(pictures/alarmclock.png)';
					} else if (state_value == 'last.fm-radio-http:*:audio/mpeg:*') {
						state_divElement.style.backgroundImage = 'url(pictures/lastfm.png)';
					} else if (state_value == 'x-file-cifs:*:audio/mpeg:*') {
						state_divElement.style.backgroundImage = 'url(pictures/list.png)';
					} else if (state_value == 'x-rincon-stream:*:*:*') {
						state_divElement.style.backgroundImage = 'url(pictures/prog.png)';
					}
				} else {
					state_divElement.style.backgroundImage = 'url(pictures/list.png)';
				}
				break;
				
			case 'SONOS_REWIND':
				if (TransportActions.indexOf('Seek') != -1) {state_divElement.style.visibility = 'visible';
				} else {state_divElement.style.visibility = 'hidden';}
				break;
				
			case 'SONOS_PREVIOUS':
				if (TransportActions.indexOf('Previous') != -1) {state_divElement.style.visibility = 'visible';
				} else {state_divElement.style.visibility = 'hidden';}
				break;
				
			case 'SONOS_STOP':
				if (TransportActions.indexOf('Stop') != -1) {state_divElement.style.visibility = 'visible';
				} else {state_divElement.style.visibility = 'hidden';}
				break;
				
			case 'SONOS_NEXT':
				if (TransportActions.indexOf('Next') != -1) {state_divElement.style.visibility = 'visible';
				} else {state_divElement.style.visibility = 'hidden';}
				break;
				
			case 'SONOS_MUTE_TOGGLE':
				state_value = GLOBAL_sonosArray["0"]["Mute"]["Master"];
				if (state_value != null){
					if (state_value == '0'){
						state_divElement.style.backgroundImage = 'url('+GLOBAL_pictureUnMute+')';
						state_divElement.onclick = new Function('sonos_sendCommand("cmd=SetMute&mute=1");');
					} else if (state_value == '1') {
						state_divElement.style.backgroundImage = 'url('+GLOBAL_pictureMute+')';
						state_divElement.onclick = new Function('sonos_sendCommand("cmd=SetMute&mute=0");');
					}
				}
				break;
				
			case 'SONOS_PLAY_PAUSE':
				state_value = GLOBAL_sonosArray["0"]["TransportState"];
				if (state_value != null){
					if (state_value == 'STOPPED'){
						state_divElement.style.backgroundImage = 'url('+GLOBAL_picturePlay+')';
						state_divElement.onclick = new Function('sonos_sendCommand("cmd=Play");');
					} else if (state_value == 'PAUSED_PLAYBACK') {
						state_divElement.style.backgroundImage = 'url('+GLOBAL_picturePlay+')';
						state_divElement.onclick = new Function('sonos_sendCommand("cmd=Play");');
					} else if (state_value == 'PLAYING') {
						state_divElement.style.backgroundImage = 'url('+GLOBAL_picturePause+')';
						state_divElement.onclick = new Function('sonos_sendCommand("cmd=Pause");');
					}
				}
				break;
				
			case 'SONOS_VOLUME_SLIDER':
				if( (GLOBAL_SliderArray[state_container] != false) && (GLOBAL_sonosArray["0"]["Volume"]["Master"]!=null) ){
					state_value = parseInt(GLOBAL_sonosArray["0"]["Volume"]["Master"]);
					jQuery('#'+state_container).slider("value",state_value);
				} 
				break;
								
				
			default:
				debug("site_sonos_updateMusicSates(): statetype unknown ("+state_typ+")");
				break;
		}
		try {page_SonosIdIterator(state_id, state_container, state_typ);} catch(err){}
	}
	try {page_SonosUpdate();} catch(err){}
}

