// -------------------------------------------------------------------------------
// HEADER BEGIN ------------------------------------------------------------------
// -------------------------------------------------------------------------------
//include_once("includes/globals.inc.js");
//include_once("includes/js/prototype.js");
//include_once("includes/js/ajax.js");
//include_once("includes/js/functions.js");
//include_once("includes/js/phpSession_functions.js");
// -------------------------------------------------------------------------------
// HEADER END --------------------------------------------------------------------
// -------------------------------------------------------------------------------

// returns the Port for the different Interfaces
function xmlRpc_getInterfacePort(var_interface){
	var port = 0;
	
	switch(var_interface.toUpperCase()){
		case 'WIRE':
		case 'WIRED':
		case 'KABEL':
		case 'HS485D':
		case 'BIDCOS-WIRED':
			port = 2000;
			break;
	
		case 'RF':
		case 'FUNK':
		case 'RFD':
		case 'BIDCOS-RF':
			port = 2001;
			break;

		case 'SYSTEM':
		case 'PFMD':
			port = 2002;
			break;

		default:
			error("xmlRpc_getInterfacePort("+var_interface+"): Unknown Interface");
			break;
	}
	return port;
}

// sets state var_state to device var_device
function xmlRpc_setDeviceState(var_interface, var_deviceSn, var_state){
	xmlRpc_setValue(var_interface, var_deviceSn, "STATE", var_state);
}

// sets level var_state to device var_device
function xmlRpc_setDeviceLevel(var_interface, var_deviceSn, var_level){
	xmlRpc_setValue(var_interface, var_deviceSn, "LEVEL", var_level);
	GLOBAL_statusArray[var_deviceSn]['WORKING'] = "true";
}

function xmlRpc_setDeviceOldLevel(var_interface, var_deviceSn){
	xmlRpc_setValueAction(var_interface, var_deviceSn, "OLD_LEVEL");
}

// send XML-RPC setValue to CCU
function xmlRpc_setValueAction(var_interface, var_dev, var_what){
	var port = xmlRpc_getInterfacePort(var_interface);
	if (var_what == "OLD_LEVEL"){
		if (GLOBAL_statusArray[var_dev] == null){
			GLOBAL_statusArray[var_dev] = new Array();
		}
		GLOBAL_statusArray[var_dev]['LEVEL'] = "0.01";
		phpSession_setValue(var_dev, 'LEVEL', "0.01");
		site_updateControls();
		GLOBAL_statusArray[var_dev]['WORKING'] = "true";
		phpSession_setValue(var_dev, 'WORKING', "true");
	} else {
		site_updateControls();
	}
	
	var params = ("port="+port+"&dev="+var_dev+"&what="+var_what+"&value=true&type=boolean");
	new Ajax.Request("../../includes/php/xmlrpc_setValue.php", {method:"get", parameters:params, onSuccess:function(transport){site_updateControls();}});
}

function xmlRpc_setValue(var_interface, var_dev, var_what, var_value){
	var port = xmlRpc_getInterfacePort(var_interface);
	if (GLOBAL_statusArray[var_dev] == null){
		GLOBAL_statusArray[var_dev] = new Array();
	}
	GLOBAL_statusArray[var_dev][var_what] = var_value;
	site_updateControls();
	var params = ("port="+port+"&dev="+var_dev+"&what="+var_what+"&value="+var_value);
	new Ajax.Request("../../includes/php/xmlrpc_setValue.php", {method:"get", parameters:params});
}

function xmlRpc_getValue(var_interface, var_dev, var_what){
	var port = xmlRpc_getInterfacePort(var_interface);
	var params = ("port="+port+"&dev="+var_dev+"&what="+var_what);
	new Ajax.Request("../../includes/php/xmlrpc_getValue.php", {
		method:"get", parameters:params, 
		onSuccess:function(transport){
			//parse response text
			var resp = jsonParse(transport.responseText);
			// if no Error is found
			if (transport.responseText.indexOf('Error') == -1){
				if (GLOBAL_statusArray[var_dev] == null){
					GLOBAL_statusArray[var_dev] = new Array();
				}
				GLOBAL_statusArray[var_dev][var_what] = resp;
				site_updateControls();
			}
	}});
}

// send XML-RPC setValue to CCU
function xmlRpc_init(){
	new Ajax.Request("../../includes/php/xmlrpc_init.php", {method:"get", parameters:"port=2000"});
	new Ajax.Request("../../includes/php/xmlrpc_init.php", {method:"get", parameters:"port=2001"});
}
function xmlRpc_deinit(){
	new Ajax.Request("../../includes/php/xmlrpc_init.php", {method:"get", parameters:"port=2000&id=deinit"});
	new Ajax.Request("../../includes/php/xmlrpc_init.php", {method:"get", parameters:"port=2001&id=deinit"});
}