<?php
require_once("../globals.inc.php");


function xml2phpArray($xml,$arr){
	$iter = 0;
	foreach($xml->children() as $b){
			$a = $b->getName();
			if(!$b->children()){
					$arr[$a] = trim($b[0]);
			}
			else{
					$arr[$a][$iter] = array();
					$arr[$a][$iter] = xml2phpArray($b,$arr[$a][$iter]);
			}
	$iter++;
	}
	return $arr;
} 

/// Sends TCL Rega Request to the CCU. $var_request is the Homematic Script, $var_trimmed defines if the result should be trimed
function Post_Request_Array ($var_request, $var_trimed=true)
{
	if (SIMULATION) {die("Simulation Mode");}
	$ccuAddress = XMLRPC_SERVER_ADDRESS;
	//fsockopen(hostname, port, errornumber, errorstring, timeout) initiates a socket connection
	$fileHandle = fsockopen ($ccuAddress, 8181, $errorNumber, $errorString, 60);
	if (!$fileHandle)
	{
		// error output
		echo "$errorString ($errorNumber)<br />\n";
		return false;
	}
	else 
	{
		$postString = "POST /tclrega.exe HTTP/1.1\r\n";
		$postString = $postString . "Content-type: application/x-www-form-urlencoded\r\n";
		$postString = $postString . "Connection: Close\r\n";
		$postString = $postString . "Content-length: ". strlen($var_request) ."\r\n\r\n";
		
		// fwrite(handle, string) writes the contents of string  to the file stream pointed to by handle . 
		fwrite($fileHandle, $postString.$var_request); 
		
		$tString = fgets($fileHandle);
		// skip over the unimportant messages to the next empty line
		while ($tString != "\r\n") 
		{
			$tString = fgets($fileHandle);
		}
		$answer = "";
		$trimedAnswer = "";
		
		// get lines
		while (!feof($fileHandle))
		{      
			$tString = fgets($fileHandle);
			$var1 = (strpos($tString, "</exec>")+strlen("</exec>"));
			$var2 = (strpos($tString, "</sessionId>")+strlen("</sessionId>"));
			$var3 = (strpos($tString, "</httpUserAgent>")+strlen("</httpUserAgent>"));
			$ende = max($var1, $var2, $var3);
				
			$answer .= $tString;
			$trimedAnswer .= "<xml>".substr($tString,$ende);
			
		}
		// Debuging
		//print_r("Debug (temp): ".htmlspecialchars($temp)."\n<br>\n<br>");
		//print_r("Debug (temp2): ".htmlspecialchars($temp2)."\n<br>\n<br>");
		
		// close socket connection
		fclose($fileHandle);
		
		// parse result
		if ($var_trimed==true)
		{
			$xml = new SimpleXMLElement($trimedAnswer);
		}
		else
		{
			$xml = new SimpleXMLElement($answer);
		}
		
		// return XML as PHP-Array
		return xml2phpArray($xml,array()); 
	}
	
	
}

/// Sends TCL Rega Request to the CCU. $var_request is the Homematic Script, $var_trimmed defines if the result should be trimed
function Post_Request_Single ($var_request, $var_trimed=true)
{
	if (SIMULATION) {die("Simulation Mode");}
	$ccuAddress = XMLRPC_SERVER_ADDRESS;
	//fsockopen(hostname, port, errornumber, errorstring, timeout) initiates a socket connection
	$fileHandle = fsockopen ($ccuAddress, 8181, $errorNumber, $errorString, 60);
	
	if (!$fileHandle)
	{
		// error output
		echo "$errorString ($errorNumber)<br />\n";
		return false;
	}
	else 
	{
		$postString = "POST /tclrega.exe HTTP/1.1\r\n";
		$postString = $postString . "Content-type: application/x-www-form-urlencoded\r\n";
		$postString = $postString . "Connection: Close\r\n";
		$postString = $postString . "Content-length: ". strlen($var_request) ."\r\n\r\n";
		
		// fwrite(handle, string) writes the contents of string  to the file stream pointed to by handle . 
		fwrite($fileHandle, $postString.$var_request); 
		
		$tString = fgets($fileHandle);
		// skip over the unimportant messages to the next empty line
		while ($tString != "\r\n") 
		{
			$tString = fgets($fileHandle);
		}
		$answer = "";
		$trimedAnswer = "";
		
		// get lines
		while (!feof($fileHandle))
		{      
			$tString = fgets($fileHandle);
			$var1 = (strpos($tString, "</exec>")+strlen("</exec>"));
			$var2 = (strpos($tString, "</sessionId>")+strlen("</sessionId>"));
			$var3 = (strpos($tString, "</httpUserAgent>")+strlen("</httpUserAgent>"));
			$ende = max($var1, $var2, $var3);
				
			$answer .= $tString;
			$trimedAnswer .= "<xml>".substr($tString,$ende);
			
		}
		// Debuging
		//print_r("Debug (temp): ".htmlspecialchars($temp)."\n<br>\n<br>");
		//print_r("Debug (temp2): ".htmlspecialchars($temp2)."\n<br>\n<br>");
		
		// close socket connection
		fclose($fileHandle);

		// parse result
		if ($var_trimed==true)
		{
			$xml = new SimpleXMLElement($trimedAnswer);
		}
		else
		{
			$xml = new SimpleXMLElement($answer);
		}
		
		// return XML as PHP-Array
		return $xml->result; 
	}
	
	
}

?>