<?php
    # Nachfolgende Funktion ist für die Ausgabe eventueller Fehler als Bild zuständig
    function error_message($text = ''){
		$text = ($text);
        header("Content-type: image/jpeg"); // Header ausgeben
        $img = imagecreatetruecolor(strlen($text) * 7, 20); // Erstellt ein neues Bild
        imagefill($img, 0, 0, imagecolorallocate($img, 255, 255, 255)); // Malt das bild weiß aus
        imagestring($img, 2, 0, 0, $text, imagecolorallocate($img, 0, 0, 0)); // Schreibt den Text der der Funktion übergeben wurde auf das Bild
        imagejpeg($img); // Gibt das Bild aus
        imagedestroy($img); // Löscht das Bild aus dem Arbeitsspeicher des Servers
    }
	
    $img_src = $_GET['src']; // Pfad zum Bild aus welchem das Thumbnail erstellt werden soll
    $cache_dir = '../../cache'; // Pfad zum Cache Verzeichnis wo später die Bilder gespeichert werden
    $cache = true; // Gibt an ob die Bilder aus dem Cache geladen werden sollen


    # Überprüft ob ein Bildpfad übergeben wurde
    if (!isset($_GET['src'])){
        error_message('Es wurde kein Bildpfad übergeben aus dem ein Thumbnail ezeugt werden könnte'); // Gibt eine Fehlermeldung aus
    }

    if (!isset($_GET['w'])){
        error_message('Es wurde keine Bildbreite übergeben'); // Gibt eine Fehlermeldung aus
    }
    if (!isset($_GET['h'])){
        error_message('Es wurde keine Bildhöhe übergeben'); // Gibt eine Fehlermeldung aus
    }
	
    $img_w = $_GET['w'];
    $img_h = $_GET['h'];


    # Auslesen der Bildgröße und des Bildtyps
    $image_infos = @getimagesize($img_src) or error_message("No File: \"" . $_GET['src'] . "\" ");
    $width = $image_infos[0];
    $height = $image_infos[1];
    $type = $image_infos[2];
    $mime = $image_infos['mime'];
	$frame_width = $img_w;
	$frame_height = $img_h;
		
	 if (($width / $frame_width) > ($height / $frame_height)){
		$new_width = intval($frame_width); // Zuweisen der neuen Breite
		$new_height = intval(($frame_width / $width) * $height);
	 } else {
		$new_height = intval($frame_height); // Zuweisen der neuen Höhe
		$new_width  = intval(($frame_height / $height) * $width);
	 }	
	$md5hash = $img_src."&h=".$img_h."&w=".$img_w;
		
	if ($new_width>$width) {$new_width=$width;}
	if ($new_height>$height) {$new_height=$height;}

    # Prüft ob das Chache Verzeichnis existiert bzw. benötigt wird und legt dieses eventuell an
    if ($cache === true && !file_exists($cache_dir)){
        mkdir($cache_dir) or error_message('Das Cache Verzeichnis konnte nicht angelegt werden'); // Legt das Cache Verzeichnis an. Sollte dies nicht möglich sein, so wird ein Fehler ausgegeben
        chmod($cache_dir, 0777); // Gibt dem Cache Verzeichniss die nötigen Schreib- und Lese Rechte
    }
    # Ermitteln des Bildtypes und Erstellung des Thumbnails
    switch ($type){
       case 1:
            header('Content-type: '.$mime); // Header ausgeben
            if (imagetypes() & IMG_GIF){ // Überprüfen ob das Bildformat untestützt wird
                if (!file_exists($cache_dir.'/'.md5($md5hash).'.gif')){ // Wenn das Thumbnail nicht existiert wird es erstellt
				    $orginal = imagecreatefromgif($img_src) or error_message('Das Bild wurde nicht gefunden'); // Bild aus dem Orginalbild erstellen
                    $thumb = imagecreatetruecolor($frame_width, $frame_height); // Das Thumbnailbild erstellen
					$black = imagecolorallocate($thumb, 0, 0, 0);
					imagefilledrectangle($thumb, 0, 0, $frame_width, $frame_height, $black);
                    //imagecopyresized($thumb, $orginal,(($frame_width/2)-($new_width/2)), (($frame_height/2)-($new_height/2)), 0, 0,  $new_width, $new_height, $width, $height);
                    imagecopyresampled($thumb, $orginal,(($frame_width/2)-($new_width/2)), (($frame_height/2)-($new_height/2)), 0, 0,  $new_width, $new_height, $width, $height);
                    if ($cache === true){ // Prüft ob das Bild gespeichert werden soll
                        imagegif($thumb, $cache_dir.'/'.md5($md5hash).'.gif') or error_message('Das Bild konnte nicht gespeichert werden'); // Bild speichern
                    }
                    imagegif($thumb); // Bild ausgeben
                } else {
                    readfile($cache_dir.'/'.md5($md5hash).'.gif') or error_message('Das Bild wurde nicht gefunden'); // Bild ausgeben
                }
            } else {
                error_message('GIF Bilder werden nicht unterstützt'); // Fehlermeldung ausgeben, wenn das Bildformat nicht unterstützt wird
            }
            break;
        case 2:
            header('Content-type: '.$mime); // Header ausgeben
            if (imagetypes() & IMG_JPG){ // Überprüfen ob das Bildformat untestützt wird
                if (!file_exists($cache_dir.'/'.md5($md5hash).'.jpg')){ // Wenn das Thumbnail nicht existiert wird es erstellt
					$orginal = imagecreatefromjpeg($img_src) or error_message('Das Bild wurde nicht gefunden'); // Bild aus dem Orginabild erstellen
                    $thumb = imagecreatetruecolor($frame_width, $frame_height); // Das Thumbnailbild erstellen
					$black = imagecolorallocate($thumb, 0, 0, 0);
					imagefilledrectangle($thumb, 0, 0, $frame_width, $frame_height, $black);
//                    imagecopyresized($thumb, $orginal,(($frame_width/2)-($new_width/2)), (($frame_height/2)-($new_height/2)), 0, 0,  $new_width, $new_height, $width, $height);
                    imagecopyresampled($thumb, $orginal,(($frame_width/2)-($new_width/2)), (($frame_height/2)-($new_height/2)), 0, 0,  $new_width, $new_height, $width, $height);
                    if ($cache === true){ // Prüft ob das Bild gespeichert werden soll
                        imagejpeg($thumb, $cache_dir.'/'.md5($md5hash).'.jpg') or error_message('Das Bild konnte nicht gespeichert werden'); // Bild speichern
                    }
                    imagejpeg($thumb); // Bild ausgeben
                } else {
                    readfile($cache_dir.'/'.md5($md5hash).'.jpg') or error_message('Das Bild wurde nicht gefunden'); // Bild ausgeben
                }
            } else {
                error_message('JPEG Bilder werden nicht unterstützt'); // Fehlermeldung ausgeben, wenn das Bildformat nicht unterstützt wird
            }
            break;
        case 3:
            header('Content-type: '.$mime); // Header ausgeben
            if (imagetypes() & IMG_PNG){ // Überprüfen ob das Bildformat untestützt wird
                if (!file_exists($cache_dir.'/'.md5($md5hash).'.png')){ // Wenn das Thumbnail nicht existiert wird es erstellt
                    $orginal = imageCreateFromPNG($img_src) or error_message('Das Bild wurde nicht gefunden'); // Bild aus dem Orginalbild erstellen
                    $thumb = imagecreatetruecolor($frame_width, $frame_height); // Das Thumbnailbild erstellen
					$black = imagecolorallocate($thumb, 0, 0, 0);
					imagefilledrectangle($thumb, 0, 0, $frame_width, $frame_height, $black);
//                    imagecopyresized($thumb, $orginal,(($frame_width/2)-($new_width/2)), (($frame_height/2)-($new_height/2)), 0, 0,  $new_width, $new_height, $width, $height);
                    imagecopyresampled($thumb, $orginal,(($frame_width/2)-($new_width/2)), (($frame_height/2)-($new_height/2)), 0, 0,  $new_width, $new_height, $width, $height);
                    if ($cache === true){ // Prüft ob das Bild gespeichert werden soll
                        imagepng($thumb, $cache_dir.'/'.md5($md5hash).'.png') or error_message('Das Bild konnte nicht gespeichert werden'); // Bild speichern
                    }
                    imagepng($thumb); // Bild ausgeben
                } else {
                    readfile($cache_dir.'/'.md5($md5hash).'.png') or error_message('Das Bild konnte nicht gespeichert werden'); // Bild ausgeben
                }
            } else {
                error_message('PNG Bilder werden nicht unterstützt'); // Fehlermeldung ausgeben, wenn das Bildformat nicht unterstützt wird
            }
            break;
        default:
            error_message('Das Bildformat wird nicht unterstützt'); // Fehlermeldung ausgeben, wenn das Bildformat nicht unterstützt wird
    }
    # Löscht das Bild aus dem Speicher des Servers falls es existiert
    if (isset($thumb)){
        imagedestroy($thumb);
    }
    if (isset($orginal)){
        imagedestroy($orginal);
    }
?>