<?php
require_once("../globals.inc.php");
if (SIMULATION) {die("Simulation Mode");}

// Sonos Player device ip-address. e.g. "192.168.0.100"
// IP-Adresse des Sonos Players z.B. "192.168.0.100"
$deviceAddress = SONOS_ADDRESS;

// Sonos Player device port. e.g. 1400 (default)
// Port des Sonos Players z.B. 1400 (standart)
$devicePort = SONOS_PORT;

// LastFM User ID e.g. "sonosrocker54"
$lfmUser = SONOS_USER;

// ---------------------------------------------------------------------
//  Do not change anything below this Line
//  Ab hier nichts verndern
// ---------------------------------------------------------------------

if ($deviceAddress == ""){
	die("no device ip-address set in script file.");	
}

if ((int)$devicePort == 0){
	die("no device port set in script file.");	
}

function StringToTime($var_timeString){
	if(strlen($var_timeString) >= 7){
		list($hours, $minutes, $seconds) = explode(":", $var_timeString);
		return ( ($hours*3600) + ($minutes*60) + $seconds );
	}
}

// check if cmd ist set.
if ( (isset($_GET["cmd"]) && ($_GET["cmd"]!="")) ){


	// Possible commands:
	// Pause, Play, Next, Previous, Rewind 
	// SetVolume (needs 'volume' parameter, e.g. volume = 25; values: 0-100)
	// SetPlayMode (needs 'mode' parameter, e.g. mode = "NORMAL"; values: "REPEAT_ALL", "SHUFFLE", "SHUFFLE_NOREPEAT", "NORMAL")
	// SetCrossfadeMode (needs 'mode' parameter, e.g. mode = 1; values: 1 = crossfading, 0 = normal)
	// SetMute (needs 'mute' parameter, e.g. mute = 1; values: 0 = normal (no mute), 1 = mute)
	// SetRadio (needs 'radio' parameter, e.g. radio = "players.creacast.com/creacast/klassik/playlist.pls"; or radio = "lsd.newmedia.tiscali-business.com/bb/redirect.lsc?content=live&media=ms&stream=ndr/live/ndr2.wma"; )
	// ClearQueue
	// AddToQueue (needs 'file' parameter, e.g. file = "192.168.1.20/mp3/playliste.m3u"; or file = "ipsserver/Public/test.mp3"; )
	// RemoveFromQueue, SetTrack (needs 'track' parameter, e.g. track = 4; values = current playlist tracknumber )
	// Info, Info2
	// InputPC, InputQueue
	// LastFmPersonal, LastFmRecommended
	// LastFmTag (needs 'lfmTag' parameter, e.g. lfmTag = "Rock"; values: actual LastFM tags, no similar tags, no search supported yet.)
	// LastFmArtist (needs 'lfmArtist' parameter, e.g. lfmArtist = "Aerosmith"; values: actual LastFM artists, no similar artists, no search supported yet.)
	$action = $_GET["cmd"];
	
	// initialize variables
	$volume = -1;
	$mute = "";
	$mode = "";
	$track = "";
	$radio = "";
	$file = "";
	$lfmTag="";
	$lfmArtist="";

	$nl = '
';
	
	switch($action)
	{
		case "Pause":
			$headerPart1 = 'POST /MediaRenderer/AVTransport/Control HTTP/1.1'.$nl;
			$headerPart2 = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#Pause"'.$nl.$nl;
			$content = 	'<u:Pause xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">'.
							'<InstanceID>0</InstanceID>'.
						'</u:Pause>';
			$contentLength = strlen($content);
			break;
		
		case "Stop":
			$headerPart1 = 'POST /MediaRenderer/AVTransport/Control HTTP/1.1'.$nl;
			$headerPart2 = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#Stop"'.$nl.$nl;
			$content = 	'<u:Stop xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">'.
							'<InstanceID>0</InstanceID>'.
						'</u:Stop>';
			$contentLength = strlen($content);
			break;
		
	   case "Play":
			$headerPart1 = 'POST /MediaRenderer/AVTransport/Control HTTP/1.1'.$nl;
			$headerPart2 = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#Play"'.$nl.$nl;
			$content = 	'<u:Play xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">'.
							'<InstanceID>0</InstanceID>'.
							'<Speed>1</Speed>'.
						'</u:Play>';
			$contentLength = strlen($content);
			break;
			
		case "Next":
			$headerPart1 = 'POST /MediaRenderer/AVTransport/Control HTTP/1.1'.$nl;
			$headerPart2 = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#Next"'.$nl.$nl;
			$content = 	'<u:Next xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">'.
							'<InstanceID>0</InstanceID>'.
						'</u:Next>';
			$contentLength = strlen($content);
			break;

		case "Previous":
			$headerPart1 = 'POST /MediaRenderer/AVTransport/Control HTTP/1.1'.$nl;
			$headerPart2 = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#Previous"'.$nl.$nl;
			$content = 	'<u:Previous xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">'.
							'<InstanceID>0</InstanceID>'.
						'</u:Previous>';
			$contentLength = strlen($content);
			break;
		
		case "Rewind":
			$headerPart1 = 'POST /MediaRenderer/AVTransport/Control HTTP/1.1'.$nl;
			$headerPart2 = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#Seek"'.$nl.$nl;
			$content = 	'<u:Seek xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">'.
							'<InstanceID>0</InstanceID>'.
							'<Unit>REL_TIME</Unit>'.
							'<Target>00:00:00</Target>'.
						'</u:Seek>';
			$contentLength = strlen($content);
			break;
		
		case "SetVolume":
			if ( (isset($_GET["volume"]) && ($_GET["volume"]!="") ) ){		
				// get volume parameter. (needs 'volume' parameter, e.g. volume = 25; values: 0-100)
				$volume = $_GET["volume"];
			} else {
				die("command 'SetVolume' selected, but no 'volume' parameter set.<br />e.g. volume = 25; values: 0-100");	
			}
			$headerPart1 = 'POST /MediaRenderer/RenderingControl/Control HTTP/1.1'.$nl;
			$headerPart2 = 'SOAPACTION: "urn:schemas-upnp-org:service:RenderingControl:1#SetVolume"'.$nl.$nl;
			$content = 	'<u:SetVolume xmlns:u="urn:schemas-upnp-org:service:RenderingControl:1">'.
							'<InstanceID>0</InstanceID>'.
							'<Channel>Master</Channel>'.
							'<DesiredVolume>'.$volume.'</DesiredVolume>'.
						'</u:SetVolume>';
			$contentLength = strlen($content)-1;
			break;

		case "SetMute":
			if ( (isset($_GET["mute"]) && ($_GET["mute"]!="") ) ){		
				// get mute parameter. (needs 'mute' parameter, e.g. mute = 1; values: 0 = normal (no mute), 1 = mute)
				$mute = $_GET["mute"];
			} else {
				die("command 'SetMute' selected, but no 'mute' parameter set.<br />e.g. mute = 1; values: 0 = normal (no mute), 1 = mute");	
			}
			$headerPart1 = 'POST /MediaRenderer/RenderingControl/Control HTTP/1.1'.$nl;
			$headerPart2 = 'SOAPACTION: "urn:schemas-upnp-org:service:RenderingControl:1#SetMute"'.$nl.$nl;
			$content = 	'<u:SetMute xmlns:u="urn:schemas-upnp-org:service:RenderingControl:1">'.
							'<InstanceID>0</InstanceID>'.
							'<Channel>Master</Channel>'.
							'<DesiredMute>'.$mute.'</DesiredMute>'.
						'</u:SetMute>';
			$contentLength = strlen($content);
			break;

		case "SetPlayMode":
			if ( (isset($_GET["mode"]) && ($_GET["mode"]!="") ) ){		
				// get mode parameter. (needs 'mode' parameter, e.g. mode = "NORMAL"; values: "REPEAT_ALL", "SHUFFLE", "SHUFFLE_NOREPEAT", "NORMAL")
				$mode = $_GET["mode"];
			} else {
				die("command 'SetPlayMode' selected, but no 'mode' parameter set.<br />e.g. mode = \"NORMAL\"; values: \"REPEAT_ALL\", \"SHUFFLE\", \"SHUFFLE_NOREPEAT\", \"NORMAL\"");	
			}
			$headerPart1 = 'POST /MediaRenderer/AVTransport/Control HTTP/1.1'.$nl;
			$headerPart2 = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#SetPlayMode"'.$nl.$nl;
			$content = 	'<u:SetPlayMode xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">'.
							'<InstanceID>0</InstanceID>'.
							'<NewPlayMode>'.$mode.'</NewPlayMode>'.
						'</u:SetPlayMode>';
			$contentLength = strlen($content);
			break;
		
		case "SetCrossfadeMode":
			if ( (isset($_GET["mode"]) && ($_GET["mode"]!="") ) ){		
				// get mode parameter. (needs 'mode' parameter, e.g. mode = 1; values: 1 = crossfading, 0 = normal)
				$mode = $_GET["mode"];
			} else {
				die("command 'SetCrossfadeMode' selected, but no 'mode' parameter set.<br />e.g. mode = 1; values: 1 = crossfading, 0 = normal");	
			}
			$headerPart1 = 'POST /MediaRenderer/AVTransport/Control HTTP/1.1'.$nl;
			$headerPart2 = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#SetCrossfadeMode"'.$nl.$nl;
			$content = 	'<u:SetCrossfadeMode xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">'.
							'<InstanceID>0</InstanceID>'.
							'<CrossfadeMode>'.$mode.'</CrossfadeMode>'.
						'</u:SetCrossfadeMode>';
			$contentLength = strlen($content);
			break;
		
		case "SetRadio":
			if ( (isset($_GET["radio"]) && ($_GET["radio"]!="") ) ){		
				// get radio parameter. (needs 'radio' parameter, e.g. radio = players.creacast.com/creacast/klassik/playlist.pls;)
				$radio = "x-rincon-mp3radio://".$_GET["radio"];
			} else {
				die("command 'SetRadio' selected, but no 'radio' parameter set.<br />e.g. radio = players.creacast.com/creacast/klassik/playlist.pls;");	
			}
			$headerPart1 = 'POST /MediaRenderer/AVTransport/Control HTTP/1.1'.$nl;
			$headerPart2 = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#SetAVTransportURI"'.$nl.$nl;
			$content = 	'<u:SetAVTransportURI xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">'.
							'<InstanceID>0</InstanceID>'.
							'<CurrentURI>'.htmlspecialchars($radio).'</CurrentURI>'.
							'<CurrentURIMetaData>&lt;DIDL-Lite xmlns:dc=&quot;http://purl.org/dc/elements/1.1/&quot; xmlns:upnp=&quot;urn:schemas-upnp-org:metadata-1-0/upnp/&quot; xmlns:r=&quot;urn:schemas-rinconnetworks-com:metadata-1-0/&quot; xmlns=&quot;urn:schemas-upnp-org:metadata-1-0/DIDL-Lite/&quot;&gt;&lt;item id=&quot;R:0/0/0&quot; parentID=&quot;R:0/0&quot; restricted=&quot;true&quot;&gt;&lt;dc:title&gt;Radio&lt;/dc:title&gt;&lt;upnp:class&gt;object.item.audioItem.audioBroadcast&lt;/upnp:class&gt;&lt;desc id=&quot;cdudn&quot; nameSpace=&quot;urn:schemas-rinconnetworks-com:metadata-1-0/&quot;&gt;SA_RINCON65031_&lt;/desc&gt;&lt;/item&gt;&lt;/DIDL-Lite&gt;</CurrentURIMetaData>'.
						'</u:SetAVTransportURI>';
			$contentLength = strlen($content);
			break;

		case "ClearQueue":
			$headerPart1 = 'POST /MediaRenderer/AVTransport/Control HTTP/1.1'.$nl;
			$headerPart2 = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#RemoveAllTracksFromQueue"'.$nl.$nl;
			$content = 	'<u:RemoveAllTracksFromQueue xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">'.
							'<InstanceID>0</InstanceID>'.
						'</u:RemoveAllTracksFromQueue>';
			$contentLength = strlen($content);
			break;

		case "AddToQueue":
			if ( (isset($_GET["file"]) && ($_GET["file"]!="") ) ){		
				// get file parameter. (needs 'file' parameter, e.g. file = "192.168.1.20/mp3/playliste.m3u";)
				$file = "x-file-cifs://".$_GET["file"];
			} else {
				die("command 'AddToQueue' selected, but no 'file' parameter set.<br />e.g. file = \"192.168.1.20/mp3/playliste.m3u\";");	
			}
			$headerPart1 = 'POST /MediaRenderer/AVTransport/Control HTTP/1.1'.$nl;
			$headerPart2 = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#AddURIToQueue"'.$nl.$nl;
			$content = 	'<u:AddURIToQueue xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">'.
							'<InstanceID>0</InstanceID>'.
							'<EnqueuedURI>'.$file.'</EnqueuedURI>'.
							'<EnqueuedURIMetaData></EnqueuedURIMetaData>'.
							'<DesiredFirstTrackNumberEnqueued>0</DesiredFirstTrackNumberEnqueued>'.
							'<EnqueueAsNext>1</EnqueueAsNext>'.
						'</u:AddURIToQueue>';
			$contentLength = strlen($content);
			break;

		case "RemoveFromQueue":
			if ( (isset($_GET["track"]) && ($_GET["track"]!="") ) ){		
				// get track parameter. (needs 'track' parameter, e.g. track = 4; values = current playlist tracknumber)
				$track = $_GET["track"];
			} else {
				die("command 'RemoveFromQueue' selected, but no 'track' parameter set.<br />e.g. track = 4; values = current playlist tracknumber");	
			}
			$headerPart1 = 'POST /MediaRenderer/AVTransport/Control HTTP/1.1'.$nl;
			$headerPart2 = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#RemoveTrackFromQueue"'.$nl.$nl;
			$content = 	'<u:RemoveTrackFromQueue xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">'.
							'<InstanceID>0</InstanceID>'.
							'<ObjectID>Q:0/'.$track.'</ObjectID>'.
						'</u:RemoveTrackFromQueue>';
			$contentLength = strlen($content);
			break;

		case "SetTrack":
			if ( (isset($_GET["track"]) && ($_GET["track"]!="") ) ){		
				// get track parameter. (needs 'track' parameter, e.g. track = 4; values = current playlist tracknumber)
				$track = $_GET["track"];
			} else {
				die("command 'SetTrack' selected, but no 'track' parameter set.<br />e.g. track = 4; values = current playlist tracknumber");	
			}
			$headerPart1 = 'POST /MediaRenderer/AVTransport/Control HTTP/1.1'.$nl;
			$headerPart2 = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#Seek"'.$nl.$nl;
			$content = 	'<u:Seek xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">'.
							'<InstanceID>0</InstanceID>'.
							'<Unit>TRACK_NR</Unit>'.
							'<Target>'.$track.'</Target>'.
						'</u:Seek>';
			$contentLength = strlen($content);
			break;

		case "Info2":
		case "Info":
			$headerPart1 = 'POST /MediaRenderer/AVTransport/Control HTTP/1.1'.$nl;
			$headerPart2 = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#GetPositionInfo"'.$nl.$nl;
			$content = 	'<u:GetPositionInfo xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">'.
							'<InstanceID>0</InstanceID>'.
						'</u:GetPositionInfo>';
			$contentLength = strlen($content);
			break;

		case "InputPC":
			$headerPart1 = 'POST /MediaRenderer/AVTransport/Control HTTP/1.1'.$nl;
			$headerPart2 = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#SetAVTransportURI"'.$nl.$nl;
			$content = 	'<u:SetAVTransportURI xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">'.
							'<InstanceID>0</InstanceID>'.
							'<CurrentURI>x-rincon-stream:RINCON_000E58114C9601400</CurrentURI>'.
							'<CurrentURIMetaData>&lt;DIDL-Lite xmlns:dc=&quot;http://purl.org/dc/elements/1.1/&quot; xmlns:upnp=&quot;urn:schemas-upnp-org:metadata-1-0/upnp/&quot; xmlns:r=&quot;urn:schemas-rinconnetworks-com:metadata-1-0/&quot; xmlns=&quot;urn:schemas-upnp-org:metadata-1-0/DIDL-Lite/&quot;&gt;&lt;item id=&quot;AI:0&quot; parentID=&quot;AI:&quot; restricted=&quot;true&quot;&gt;&lt;dc:title&gt;Computer&lt;/dc:title&gt;&lt;upnp:class&gt;object.item.audioItem&lt;/upnp:class&gt;&lt;desc id=&quot;cdudn&quot; nameSpace=&quot;urn:schemas-rinconnetworks-com:metadata-1-0/&quot;&gt;RINCON_000E58114C9601400&lt;/desc&gt;&lt;/item&gt;&lt;/DIDL-Lite&gt;</CurrentURIMetaData>'.
						'</u:SetAVTransportURI>';
			$contentLength = strlen($content);
			break;
		
		case "InputQueue":
			$headerPart1 = 'POST /MediaRenderer/AVTransport/Control HTTP/1.1'.$nl;
			$headerPart2 = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#SetAVTransportURI"'.$nl.$nl;
			$content = 	'<u:SetAVTransportURI xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">'.
							'<InstanceID>0</InstanceID>'.
							'<CurrentURI>x-rincon-queue:RINCON_000E58114C9601400#0</CurrentURI>'.
							'<CurrentURIMetaData></CurrentURIMetaData>'.
						'</u:SetAVTransportURI>';
			$contentLength = strlen($content);
			break;

		case "LastFmPersonal":
			if ($lfmUser == ""){		
				die("command 'LastFmPersonal' selected, but no 'lfmUser' parameter set in script file.");	
			}
			$headerPart1 = 'POST /MediaRenderer/AVTransport/Control HTTP/1.1'.$nl;
			$headerPart2 = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#SetAVTransportURI"'.$nl.$nl;
			$content = 	'<u:SetAVTransportURI xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">'.
							'<InstanceID>0</InstanceID>'.
							'<CurrentURI>lastfm://user/'.$lfmUser.'/personal</CurrentURI>'.
							'<CurrentURIMetaData>&lt;DIDL-Lite xmlns:dc=&quot;http://purl.org/dc/elements/1.1/&quot; xmlns:upnp=&quot;urn:schemas-upnp-org:metadata-1-0/upnp/&quot; xmlns:r=&quot;urn:schemas-rinconnetworks-com:metadata-1-0/&quot; xmlns=&quot;urn:schemas-upnp-org:metadata-1-0/DIDL-Lite/&quot;&gt;&lt;item id=&quot;RP:SA_RINCON11_'.$lfmUser.':0:PERSONALRADIO&quot; parentID=&quot;RECENT&quot; restricted=&quot;true&quot;&gt;&lt;dc:title&gt;Meine Bibliothek&lt;/dc:title&gt;&lt;upnp:class&gt;object.item.audioItem.audioBroadcast&lt;/upnp:class&gt;&lt;desc id=&quot;cdudn&quot; nameSpace=&quot;urn:schemas-rinconnetworks-com:metadata-1-0/&quot;&gt;SA_RINCON11_'.$lfmUser.'&lt;/desc&gt;&lt;/item&gt;&lt;/DIDL-Lite&gt;</CurrentURIMetaData>'.
						'</u:SetAVTransportURI>';
			$contentLength = strlen($content);
			break;

		case "LastFmRecommended":
			if ($lfmUser == ""){		
				die("command 'LastFmRecommended' selected, but no 'lfmUser' parameter set in script file.");	
			}
			$headerPart1 = 'POST /MediaRenderer/AVTransport/Control HTTP/1.1'.$nl;
			$headerPart2 = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#SetAVTransportURI"'.$nl.$nl;
			$content = 	'<u:SetAVTransportURI xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">'.
							'<InstanceID>0</InstanceID>'.
							'<CurrentURI>lastfm://user/'.$lfmUser.'/recommended</CurrentURI>'.
							'<CurrentURIMetaData>&lt;DIDL-Lite xmlns:dc=&quot;http://purl.org/dc/elements/1.1/&quot; xmlns:upnp=&quot;urn:schemas-upnp-org:metadata-1-0/upnp/&quot; xmlns:r=&quot;urn:schemas-rinconnetworks-com:metadata-1-0/&quot; xmlns=&quot;urn:schemas-upnp-org:metadata-1-0/DIDL-Lite/&quot;&gt;&lt;item id=&quot;RP:SA_RINCON11_'.$lfmUser.':6:RECOMMENDED&quot; parentID=&quot;RECENT&quot; restricted=&quot;true&quot;&gt;&lt;dc:title&gt;Meine Empfehlungen&lt;/dc:title&gt;&lt;upnp:class&gt;object.item.audioItem.audioBroadcast&lt;/upnp:class&gt;&lt;desc id=&quot;cdudn&quot; nameSpace=&quot;urn:schemas-rinconnetworks-com:metadata-1-0/&quot;&gt;SA_RINCON11_'.$lfmUser.'&lt;/desc&gt;&lt;/item&gt;&lt;/DIDL-Lite&gt;</CurrentURIMetaData>'.
						'</u:SetAVTransportURI>';
			$contentLength = strlen($content);
			break;

		case "LastFmTag":
			if ($lfmUser == ""){		
				die("command 'LastFmTag' selected, but no 'lfmUser' parameter set in script file.");	
			}

			if ( (isset($_GET["lfmTag"]) && ($_GET["lfmTag"]!="") ) ){		
				// get lfmTag parameter. (needs 'lfmTag' parameter, e.g. lfmTag = "Rock"; values: actual LastFM tags, no similar tags, no search supported yet.)
				$lfmTag = $_GET["lfmTag"];
			} else {
				die("command 'LastFmTag' selected, but no 'lfmTag' parameter set.<br />e.g. lfmTag = \"Rock\"; values: actual LastFM tags, no similar tags, no search supported yet.");	
			}
			
			$headerPart1 = 'POST /MediaRenderer/AVTransport/Control HTTP/1.1'.$nl;
			$headerPart2 = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#SetAVTransportURI"'.$nl.$nl;
			$content = 	'<u:SetAVTransportURI xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">'.
							'<InstanceID>0</InstanceID>'.
							'<CurrentURI>lastfm://globaltags/'.$lfmTag.'</CurrentURI>'.
							'<CurrentURIMetaData>&lt;DIDL-Lite xmlns:dc=&quot;http://purl.org/dc/elements/1.1/&quot; xmlns:upnp=&quot;urn:schemas-upnp-org:metadata-1-0/upnp/&quot; xmlns:r=&quot;urn:schemas-rinconnetworks-com:metadata-1-0/&quot; xmlns=&quot;urn:schemas-upnp-org:metadata-1-0/DIDL-Lite/&quot;&gt;&lt;item id=&quot;LFM:TAG:'.$lfmTag.'&quot; parentID=&quot;SEARCHTAGS:'.$lfmTag.'&quot; restricted=&quot;true&quot;&gt;&lt;dc:title&gt;'.$lfmTag.'&lt;/dc:title&gt;&lt;upnp:class&gt;object.item.audioItem.audioBroadcast&lt;/upnp:class&gt;&lt;desc id=&quot;cdudn&quot; nameSpace=&quot;urn:schemas-rinconnetworks-com:metadata-1-0/&quot;&gt;SA_RINCON11_'.$lfmUser.'&lt;/desc&gt;&lt;/item&gt;&lt;/DIDL-Lite&gt;</CurrentURIMetaData>'.
						'</u:SetAVTransportURI>';
			$contentLength = strlen($content);
			break;

		case "LastFmArtist":
			if ($lfmUser == ""){		
				die("command 'LastFmArtist' selected, but no 'lfmUser' parameter set in script file.");	
			}
			
			if ( (isset($_GET["lfmArtist"]) && ($_GET["lfmArtist"]!="") ) ){		
				// get lfmArtist parameter. (needs 'lfmArtist' parameter, e.g. lfmArtist = "Aerosmith"; values: actual LastFM artists, no similar artists, no search supported yet.)
				$lfmArtist = $_GET["lfmArtist"];
			} else {
				die("command 'LastFmArtist' selected, but no 'lfmArtist' parameter set.<br />e.g. lfmArtist = \"Aerosmith\"; values: actual LastFM artists, no similar artists, no search supported yet.");	
			}
			
			$headerPart1 = 'POST /MediaRenderer/AVTransport/Control HTTP/1.1'.$nl;
			$headerPart2 = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#SetAVTransportURI"'.$nl.$nl;
			$content = 	'<u:SetAVTransportURI xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">'.
							'<InstanceID>0</InstanceID>'.
							'<CurrentURI>lastfm://artist/'.$lfmArtist.'/similarartists</CurrentURI>'.
							'<CurrentURIMetaData>&lt;DIDL-Lite xmlns:dc=&quot;http://purl.org/dc/elements/1.1/&quot; xmlns:upnp=&quot;urn:schemas-upnp-org:metadata-1-0/upnp/&quot; xmlns:r=&quot;urn:schemas-rinconnetworks-com:metadata-1-0/&quot; xmlns=&quot;urn:schemas-upnp-org:metadata-1-0/DIDL-Lite/&quot;&gt;&lt;item id=&quot;LFM:ARTIST:'.$lfmArtist.'&quot; parentID=&quot;SEARCHARTISTS:'.$lfmArtist.'&quot; restricted=&quot;true&quot;&gt;&lt;dc:title&gt;'.$lfmArtist.'&lt;/dc:title&gt;&lt;upnp:class&gt;object.item.audioItem.audioBroadcast&lt;/upnp:class&gt;&lt;desc id=&quot;cdudn&quot; nameSpace=&quot;urn:schemas-rinconnetworks-com:metadata-1-0/&quot;&gt;SA_RINCON11_'.$lfmUser.'&lt;/desc&gt;&lt;/item&gt;&lt;/DIDL-Lite&gt;</CurrentURIMetaData>'.
						'</u:SetAVTransportURI>';
			$contentLength = strlen($content);
			break;
	
		default:
			die("'".$action."' is no valid command.");
			break;
	} 
	
	// envelope strings
	$contentEnvelopeBegin = '<s:Envelope xmlns:s="http://schemas.xmlsoap.org/soap/envelope/" s:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"><s:Body>';
	$contentEnvelopeEnd = '</s:Body></s:Envelope>';
	// add envelope string legth to contentLength
	$contentLength += 154;

	// build message header part 1
	$headerMainPart = 	'CONNECTION: close'.$nl.
						'HOST: '.$deviceAddress.':'.$devicePort.$nl.
						'CONTENT-LENGTH: '.$contentLength.$nl.
						'CONTENT-TYPE: text/xml; charset="utf-8"'.$nl;
	
	// build complete UPnP-AV message for Sonos device
	$streamMessage = $headerPart1.$headerMainPart.$headerPart2.$contentEnvelopeBegin.$content.$contentEnvelopeEnd;
	
	// debug
	//die($headerPart1.$headerMainPart.$headerPart2.htmlspecialchars($contentEnvelopeBegin.$content.$contentEnvelopeEnd));


	//	fsockopen(hostname, port, errornumber, errorstring, timeout) initiates a socket connection
	$fileHandle = fsockopen ($deviceAddress, $devicePort, $errorNumber, $errorString, 10);
	
	if (!$fileHandle)
	{
		// error output
		echo "$errorString ($errorNumber)<br />\n";
	}
	else 
	{
		// fwrite(handle, string) writes the contents of string  to the file stream pointed to by handle . 
		fputs($fileHandle, $streamMessage); 
		$streamAnswer = "";
		
		// get lines
		while (!feof($fileHandle))
		{      
			$streamAnswer .= fgets($fileHandle);
		}
		// close socket connection
		fclose($fileHandle);
	}

	$PositionInfo["Artist"] = "";
	$PositionInfo["Title"] = "";
	$PositionInfo["Album"] = "";
	$PositionInfo["Picture"] = "";
	$PositionInfo["RelTime"] = "";
	$PositionInfo["TrackDuration"] = "";
	$PositionInfo["RelTimeSec"] = "";
	$PositionInfo["TrackDurationSec"] = "";
	$PositionInfo["TrackURI"] = "";
	$PositionInfo["TrackMetaData"] = "";
	$PositionInfo["TEST"] = "/";
		
	//Rckgabe
	$PositionInfo["RelTime"] = substr($streamAnswer, strpos($streamAnswer, "<RelTime>")+9, 7);
	if ($PositionInfo["RelTime"][1] != ":"){
		$PositionInfo["RelTime"] = "";
	}
	
	$TrackMetaData_start = strpos($streamAnswer, "<TrackMetaData>")+15;
	$TrackMetaData_end = strpos($streamAnswer, "</TrackMetaData>");
	if(($TrackMetaData_start != 0) && ($TrackMetaData_end != 0)){
		$PositionInfo["TrackMetaData"] = (substr($streamAnswer, $TrackMetaData_start, ($TrackMetaData_end - $TrackMetaData_start)));
	}
	
	$TrackURI_start = strpos($streamAnswer, "<TrackURI>")+10;
	$TrackURI_end = strpos($streamAnswer, "</TrackURI>");
	if(($TrackURI_start != 0) && ($TrackURI_end != 0)){
		$PositionInfo["TrackURI"] = substr($streamAnswer, $TrackURI_start, ($TrackURI_end - $TrackURI_start));
	}
	
	$PositionInfo["TrackDuration"] = substr($streamAnswer, strpos($streamAnswer, "<TrackDuration>")+15, 7);
	if ($PositionInfo["TrackDuration"][1] != ":"){
		$PositionInfo["TrackDuration"] = "";
	}
	$PositionInfo["RelTimeSec"] = StringToTime($PositionInfo["RelTime"]);
	$PositionInfo["TrackDurationSec"] = StringToTime($PositionInfo["TrackDuration"]);
	
	$Artist_start = strpos($streamAnswer, "&lt;dc:creator&gt;")+18;
	$Artist_end = strpos($streamAnswer, "&lt;/dc:creator&gt;");
	if(($Artist_start != 0) && ($Artist_end != 0)){
		$PositionInfo["Artist"] = htmlspecialchars_decode(substr($streamAnswer, $Artist_start, ($Artist_end - $Artist_start)));
	}
	
	$Title_start = strpos($streamAnswer, "&lt;dc:title&gt;")+16;
	$Title_end = strpos($streamAnswer, "&lt;/dc:title&gt;");
	if(($Title_start != 0) && ($Title_end != 0)){
		$PositionInfo["Title"] = htmlspecialchars_decode(substr($streamAnswer, $Title_start, ($Title_end - $Title_start)));
	}
	
	$Album_start = strpos($streamAnswer, "&lt;upnp:album&gt;")+18;
	$Album_end = strpos($streamAnswer, "&lt;/upnp:album&gt;");
	if(($Album_start != 0) && ($Album_end != 0)){
		$PositionInfo["Album"] = htmlspecialchars_decode(substr($streamAnswer, $Album_start, ($Album_end - $Album_start)));
	}
	
	$Picture_start = strpos($streamAnswer, "&lt;upnp:albumArtURI&gt;")+24;
	$Picture_end = strpos($streamAnswer, "&lt;/upnp:albumArtURI&gt;");
	if(($Picture_start != 0) && ($Picture_end != 0)){
		$PositionInfo["Picture"] = substr($streamAnswer, $Picture_start, ($Picture_end - $Picture_start));
	}
	
	if ($action == "Info") {
		print_r(json_encode($PositionInfo));
	} else {
		echo($headerPart1.$headerMainPart.$headerPart2.htmlspecialchars($contentEnvelopeBegin.$content.$contentEnvelopeEnd));
		echo("<br>");
		echo("<br>");
		echo htmlspecialchars($streamAnswer);
	}
} else {
	die("no command set.");	
}
?>