<?php
	require_once("../globals.inc.php");
	if (SIMULATION) {die("Simulation Mode");}
	
	// Sonos Player device ip-address. e.g. "192.168.0.100"
	// IP-Adresse des Sonos Players z.B. "192.168.0.100"
	$deviceAddress = SONOS_ADDRESS;
	
	// Sonos Player device port. e.g. 1400 (default)
	// Port des Sonos Players z.B. 1400 (standart)
	$devicePort = SONOS_PORT;
	
	$instanceId = SONOS_INSTANCE_ID;
	$sessionId = SONOS_SESSION_ID;


	session_id($sessionId);
	session_start();
	
	if ($deviceAddress == ""){
		die("no device ip-address set in script file.");	
	}
	
	if ((int)$devicePort == 0){
		die("no device port set in script file.");	
	}
	
	function StringToTime($var_timeString){
		$hours = 0;
		$minutes = 0;
		$seconds = 0;
		if(strlen($var_timeString) >= 7){
			list($hours, $minutes, $seconds) = explode(":", $var_timeString);
			$result = ( (((int)$hours)*3600) + (((int)$minutes*60)) + ((int)$seconds) );
			return $result;
		}
		
	}

	function update(&$var_container = "notacontainer", $var_string){
		if ( ($var_container != "notacontainer") && (isset($var_string)) ){
			if($var_string != ""){
				$var_container = (string)$var_string;
			} 
		}
	}


	$nl = '
';
		
	$headerPart1 = 'POST /MediaRenderer/AVTransport/Control HTTP/1.1'.$nl;
	$headerPart2 = 'SOAPACTION: "urn:schemas-upnp-org:service:AVTransport:1#GetPositionInfo"'.$nl.$nl;
	$content = 	'<u:GetPositionInfo xmlns:u="urn:schemas-upnp-org:service:AVTransport:1">'.
					'<InstanceID>'.$instanceId.'</InstanceID>'.
				'</u:GetPositionInfo>';
	$contentLength = strlen($content);
	
	// envelope strings
	$contentEnvelopeBegin = '<s:Envelope xmlns:s="http://schemas.xmlsoap.org/soap/envelope/" s:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"><s:Body>';
	$contentEnvelopeEnd = '</s:Body></s:Envelope>';
	// add envelope string legth to contentLength
	$contentLength += 154;
	
	// build message header part 1
	$headerMainPart = 	'CONNECTION: close'.$nl.
						'HOST: '.$deviceAddress.':'.$devicePort.$nl.
						'CONTENT-LENGTH: '.$contentLength.$nl.
						'CONTENT-TYPE: text/xml; charset="utf-8"'.$nl;
	
	// build complete UPnP-AV message for Sonos device
	$streamMessage = $headerPart1.$headerMainPart.$headerPart2.$contentEnvelopeBegin.$content.$contentEnvelopeEnd;
	
	//	fsockopen(hostname, port, errornumber, errorstring, timeout) initiates a socket connection
	$fileHandle = fsockopen ($deviceAddress, $devicePort, $errorNumber, $errorString, 10);
	
	if (!$fileHandle)
	{
		// error output
		echo "$errorString ($errorNumber)<br />\n";
	}
	else 
	{
		// fwrite(handle, string) writes the contents of string  to the file stream pointed to by handle . 
		fputs($fileHandle, $streamMessage); 
		$streamAnswer = "";
		$fullAnswer = "";
		
		// get lines
		while (!feof($fileHandle))
		{
			//get only last line (no  headers)
			$positionAnswer = fgets($fileHandle);
			$fullAnswer .= $positionAnswer;
		}
		// close socket connection
		fclose($fileHandle);
	}
	
	$xml = simplexml_load_string($positionAnswer);
	$namespaces = $xml->getNameSpaces(true);

	if ($xml->children($namespaces['s'])->Body->children($namespaces['u'])->GetPositionInfoResponse->children($namespaces[''])->TrackMetaData !='NOT_IMPLEMENTED') $TrackMetaDataXml = simplexml_load_string((string)($xml->children($namespaces['s'])->Body->children($namespaces['u'])->GetPositionInfoResponse->children($namespaces[''])->TrackMetaData));
	if ($TrackMetaDataXml){ 
		$TrackMetaDataNamespaces = $TrackMetaDataXml->getNameSpaces(true);

		if ($_SESSION['SONOS'][$instanceId]['CurrentTrackData'] == null){$_SESSION['SONOS'][$instanceId]['CurrentTrackData'] = array();}
		update($_SESSION['SONOS'][$instanceId]['CurrentTrackData']['id'], $TrackMetaDataXml->item->attributes()->id);
		update($_SESSION['SONOS'][$instanceId]['CurrentTrackData']['parentID'], $TrackMetaDataXml->item->attributes()->parentID);
		update($_SESSION['SONOS'][$instanceId]['CurrentTrackData']['restricted'], $TrackMetaDataXml->item->attributes()->restricted);
		update($_SESSION['SONOS'][$instanceId]['CurrentTrackData']['protocolInfo'], $TrackMetaDataXml->item->res->attributes()->protocolInfo);
		update($_SESSION['SONOS'][$instanceId]['CurrentTrackData']['Duration'], $TrackMetaDataXml->item->res->attributes()->duration);
		update($_SESSION['SONOS'][$instanceId]['CurrentTrackData']['URI'], $TrackMetaDataXml->item->res);
		update($_SESSION['SONOS'][$instanceId]['CurrentTrackData']['streamContent'], $TrackMetaDataXml->item->children($TrackMetaDataNamespaces['r'])->streamContent);
		update($_SESSION['SONOS'][$instanceId]['CurrentTrackData']['radioShowMd'], $TrackMetaDataXml->item->children($TrackMetaDataNamespaces['r'])->radioShowMd);
		update($_SESSION['SONOS'][$instanceId]['CurrentTrackData']['albumArtURI'], rawurlencode($TrackMetaDataXml->item->children($TrackMetaDataNamespaces['upnp'])->albumArtURI));
		update($_SESSION['SONOS'][$instanceId]['CurrentTrackData']['title'], $TrackMetaDataXml->item->children($TrackMetaDataNamespaces['dc'])->title);
		update($_SESSION['SONOS'][$instanceId]['CurrentTrackData']['class'], $TrackMetaDataXml->item->children($TrackMetaDataNamespaces['upnp'])->class);
		update($_SESSION['SONOS'][$instanceId]['CurrentTrackData']['creator'], $TrackMetaDataXml->item->children($TrackMetaDataNamespaces['dc'])->creator);
		update($_SESSION['SONOS'][$instanceId]['CurrentTrackData']['album'], $TrackMetaDataXml->item->children($TrackMetaDataNamespaces['upnp'])->album);
		update($_SESSION['SONOS'][$instanceId]['CurrentTrackData']['originalTrackNumber'], $TrackMetaDataXml->item->children($TrackMetaDataNamespaces['upnp'])->originalTrackNumber);
		update($_SESSION['SONOS'][$instanceId]['CurrentTrackData']['albumArtist'], $TrackMetaDataXml->item->children($TrackMetaDataNamespaces['r'])->albumArtist);

	
	}
	
	$innerXml = $xml->children($namespaces['s'])->Body->children($namespaces['u'])->GetPositionInfoResponse->children($namespaces['']);
	if ($innerXml){
		update($_SESSION['SONOS'][$instanceId]['Track'], $innerXml->Track);
		update($_SESSION['SONOS'][$instanceId]['CurrentTrackDuration'], $innerXml->TrackDuration);
		update($_SESSION['SONOS'][$instanceId]['CurrentTrackDurationSeconds'], (string)StringToTime($innerXml->TrackDuration));
		update($_SESSION['SONOS'][$instanceId]['RelTime'], $innerXml->RelTime);
		update($_SESSION['SONOS'][$instanceId]['RelTimeSeconds'], (string)StringToTime($innerXml->RelTime));
		update($_SESSION['SONOS'][$instanceId]['RelCount'], $innerXml->RelCount);
		update($_SESSION['SONOS'][$instanceId]['AbsCount'], $innerXml->AbsCount);
	}
	echo((int)$_SESSION['SONOS'][$instanceId]['RelTimeSeconds']);

//	// debug
//	if($TrackMetaDataXml) print_r(htmlspecialchars($TrackMetaDataXml->asXml()));
//	echo ("<br />");
//	echo ("<br />");
//	echo ("<br />");
//	print_r(htmlspecialchars($innerXml->RelTime->asXml()));
//	echo ("<br />");
//	echo ("<br />");
//	echo ("<br />");
//	print_r(htmlspecialchars($xml->asXml()));
//	echo ("<br />");
//	echo ("<br />");
//	echo ("<br />");
//	echo htmlspecialchars($positionAnswer);

?>