<?php
require_once("../globals.inc.php");
if (SIMULATION) {die("Simulation Mode");}

function array_remove(array &$a_Input, $m_SearchValue, $b_Strict = False) {
    $a_Keys = array_keys($a_Input, $m_SearchValue, $b_Strict);
    foreach($a_Keys as $s_Key) {
        unset($a_Input[$s_Key]);
    }
    return $a_Input;
}

// Sonos Player device ip-address. e.g. "192.168.0.100"
// IP-Adresse des Sonos Players z.B. "192.168.0.100"
$deviceAddress = SONOS_ADDRESS;

// Sonos Player device port. e.g. 1400 (default)
// Port des Sonos Players z.B. 1400 (standart)
$devicePort = SONOS_PORT;
$eventTimeout = SONOS_TIMEOUT;
$callbackPath = SONOS_CLIENT_COMPLETE_PATH;
$nl = '
';
	
session_id(SONOS_SESSION_ID);
session_start();


//"SUBSCRIBE /MediaRenderer/AVTransport/Event HTTP/1.1
//HOST: 192.168.0.21:1400
//USER-AGENT: Linux UPnP/1.0 Sonos/13.7-29120
//CALLBACK: <http://192.168.0.6:80/test/suscriber.php>
//NT: upnp:event
//TIMEOUT: Second-3600
//
//"

$action = $_GET["cmd"];
$streamMessage = "";

if ($_SESSION['SONOS'] == null){$_SESSION['SONOS'] = array();}
if ($_SESSION['SONOS']['SIDs'] == null){$_SESSION['SONOS']['SIDs'] = array();}


if( $action == "zone") {
	$subscrition = "ZoneGroupTopology";
	$eventName = "ZoneGroup";

} elseif ($action == "server") {
	$subscrition = "MediaServer/ContentDirectory";
	$eventName = "ContentDirectory";

} elseif ($action == "render") {
	$subscrition = "MediaRenderer/RenderingControl";
	$eventName = "RenderingControl";

} elseif ($action == "av") {
	$subscrition = "MediaRenderer/AVTransport";
	$eventName = "AVTransport";

}

array_remove($_SESSION['SONOS']['SIDs'], $subscrition);


$streamMessage = 	"SUBSCRIBE /".$subscrition."/Event HTTP/1.1".$nl.
					"HOST: ".$deviceAddress.":".$devicePort.$nl.
					"USER-AGENT: Linux UPnP/1.0 Sonos/13.7-29120".$nl.
					"CALLBACK: <".$callbackPath.">".$nl.
					"NT: upnp:event".$nl.
					"TIMEOUT: Second-".$eventTimeout.$nl.$nl;


if ($streamMessage != ""){
	//	fsockopen(hostname, port, errornumber, errorstring, timeout) initiates a socket connection
	$fileHandle = fsockopen ($deviceAddress, $devicePort, $errorNumber, $errorString, 10);
	
	if (!$fileHandle) {
		// error output
		echo "$errorString ($errorNumber)<br />\n";
	} else {
		// fwrite(handle, string) writes the contents of string  to the file stream pointed to by handle . 
		fputs($fileHandle, $streamMessage); 
		$streamAnswer = "";
		
		// get lines
		while (!feof($fileHandle)) {      
			$streamAnswer .= fgets($fileHandle);
		}
		// close socket connection
		fclose($fileHandle);
	}

	echo htmlspecialchars($streamAnswer);
	
	$seperator = strpos($streamAnswer, "uuid");
	$uuid = substr($streamAnswer, $seperator, (strpos($streamAnswer, "\r", $seperator)-(int)$seperator));
	
	$_SESSION['SONOS']['SIDs'][$uuid] = $subscrition;
	
}

?>