<?php
	require_once("../globals.inc.php");

	$ver = phpversion();
	$rawData = '';
	$eventType = 'unknown';
	$writeOutput = true;
	$deleteWorking = true;
	$inhalt = '';
	$sessionId = '';
	$sessionId = SONOS_SESSION_ID;

	//$currentDateTime = date("d.m.Y-H:i:s");
	$currentDateTime = date("F d, Y H:i:s");

	
	function update(&$var_container = "notacontainer", $var_string){
		if ( ($var_container != "notacontainer") && (isset($var_string)) ){
			$var_container = (string)$var_string;
		}
	}
	
	function StringToTime($var_timeString){
		$hours = 0;
		$minutes = 0;
		$seconds = 0;
		if(strlen($var_timeString) >= 7){
			list($hours, $minutes, $seconds) = explode(":", $var_timeString);
			return ( (((int)$hours)*3600) + (((int)$minutes*60)) + ((int)$seconds) );
		}
	}
	
	// workaround for a known bug in php ver. 5.2.2 that broke $HTTP_RAW_POST_DATA
	if ($ver[0] >= 5)
	{
		$rawData = file_get_contents('php://input');
	}
	else
	{
		$rawData = isset($GLOBALS['HTTP_RAW_POST_DATA']) ? $GLOBALS['HTTP_RAW_POST_DATA'] : '';
	}

	foreach($_SERVER as $i=>$val) {  
		if (strpos($i, 'HTTP_') === 0) {  
			$rawHeader[$i] = $val;
		}
	}  
	$rawHeader['REQUEST_METHOD'] = $_SERVER['REQUEST_METHOD'];
	
	//Content
	
	if ( (isset($_GET["sessid"]) && ($_GET["sessid"]!="")) ){
		$sessionId = $_GET["sessid"];
	}
	
	session_id($sessionId);
	session_start();
	
	if (isset($rawHeader['HTTP_SID'])){
		$uuid = $rawHeader['HTTP_SID'];
		$eventType = $_SESSION['SONOS']['SIDs'][$uuid];

	}

	$filename = "log/".$eventType."/".date("M-j G-i-s").".txt";
	if ($writeOutput == true){
		if (!is_dir("log/".$eventType."/")){mkdir("log/".$eventType."/", 0777, true);}
		$handle  = fopen((string)$filename, "w");
		fwrite ($handle, $rawData);
		fclose ($handle);
	}

	$xml = simplexml_load_string($rawData);
	$namespaces = $xml->getNameSpaces(true);

	switch($eventType)
	{
		case "ZoneGroupTopology":
			
			break;
			
		case "MediaServer/ContentDirectory":
			
			break;
	
		case "MediaRenderer/RenderingControl":
			$innerXml = simplexml_load_string((string)($xml->children($namespaces['e'])->property->children('')->LastChange));
			
			foreach($innerXml->InstanceID as $InstanceID){
				$id = (string)$InstanceID->attributes()->val;
				if ($_SESSION['SONOS'][$id] == null){$_SESSION['SONOS'][$id] = array();}
				
				if ($_SESSION['SONOS'][$id]['Volume'] == null){$_SESSION['SONOS'][$id]['Volume'] = array();}
				foreach($InstanceID->Volume as $volume){
					update($_SESSION['SONOS'][$id]['Volume'][(string)$volume->attributes()->channel], $volume->attributes()->val);
				}
				
				if ($_SESSION['SONOS'][$id]['Mute'] == null){$_SESSION['SONOS'][$id]['Mute'] = array();}
				foreach($InstanceID->Mute as $volume){
					update($_SESSION['SONOS'][$id]['Mute'][(string)$volume->attributes()->channel], $volume->attributes()->val);
				}
				
				if ($InstanceID->Bass) update($_SESSION['SONOS'][$id]['Bass'], $InstanceID->Bass->attributes()->val);
				
				if ($InstanceID->Treble) update($_SESSION['SONOS'][$id]['Treble'], $InstanceID->Treble->attributes()->val);
				
				if ($_SESSION['SONOS'][$id]['Loudness'] == null){$_SESSION['SONOS'][$id]['Loudness'] = array();}
				if ($InstanceID->Loudness) update($_SESSION['SONOS'][$id]['Loudness'][(string)$InstanceID->Loudness->attributes()->channel], $InstanceID->Loudness->attributes()->val);
				
				if ($InstanceID->OutputFixed) update($_SESSION['SONOS'][$id]['OutputFixed'], $InstanceID->OutputFixed->attributes()->val);
				
				if ($InstanceID->HeadphoneConnected) update($_SESSION['SONOS'][$id]['HeadphoneConnected'], $InstanceID->HeadphoneConnected->attributes()->val);

				if ($InstanceID->PresetNameList) update($_SESSION['SONOS'][$id]['PresetNameList'], $InstanceID->PresetNameList);
			}
			break;
	
		case "MediaRenderer/AVTransport":
			$innerXml = simplexml_load_string((string)($xml->children($namespaces['e'])->property->children('')->LastChange));
			$innerNamespaces = $innerXml->getNameSpaces(true);
			
			foreach($innerXml->InstanceID as $InstanceID){
				$id = (string)$InstanceID->attributes()->val;
				if ($_SESSION['SONOS'][$id] == null){$_SESSION['SONOS'][$id] = array();}
				if ($InstanceID->TransportState) update($_SESSION['SONOS'][$id]['TransportState'], $InstanceID->TransportState->attributes()->val);
				if ($InstanceID->CurrentPlayMode) update($_SESSION['SONOS'][$id]['CurrentPlayMode'], $InstanceID->CurrentPlayMode->attributes()->val);
				if ($InstanceID->CurrentCrossfadeMode) update($_SESSION['SONOS'][$id]['CurrentCrossfadeMode'], $InstanceID->CurrentCrossfadeMode->attributes()->val);
				if ($InstanceID->NumberOfTracks) update($_SESSION['SONOS'][$id]['NumberOfTracks'], $InstanceID->NumberOfTracks->attributes()->val);
				if ($InstanceID->CurrentTrack) update($_SESSION['SONOS'][$id]['CurrentTrack'], $InstanceID->CurrentTrack->attributes()->val);
				if ($InstanceID->CurrentSection) update($_SESSION['SONOS'][$id]['CurrentSection'], $InstanceID->CurrentSection->attributes()->val);
				if ($InstanceID->CurrentTrackDuration) update($_SESSION['SONOS'][$id]['CurrentTrackDuration'], $InstanceID->CurrentTrackDuration->attributes()->val);
				if ($InstanceID->CurrentTrackDuration) update($_SESSION['SONOS'][$id]['CurrentTrackDurationSeconds'], StringToTime($InstanceID->CurrentTrackDuration->attributes()->val));

				$temp = $InstanceID->CurrentTrackMetaData->attributes()->val;
				if ( isset($temp) ){
					if($temp == ""){
						$_SESSION['SONOS'][$id]['CurrentTrackData'] = '';
					} else {
						$CurrentTrackMetaDataXml = simplexml_load_string((string)($temp));
						if(is_object($CurrentTrackMetaDataXml)){
							$CurrentNamespaces = $CurrentTrackMetaDataXml->getNameSpaces(true);
						
							if ($_SESSION['SONOS'][$id]['CurrentTrackData'] == null){$_SESSION['SONOS'][$id]['CurrentTrackData'] = array();}
							update($_SESSION['SONOS'][$id]['CurrentTrackData']['id'], $CurrentTrackMetaDataXml->item->attributes()->id);
							update($_SESSION['SONOS'][$id]['CurrentTrackData']['parentID'], $CurrentTrackMetaDataXml->item->attributes()->parentID);
							update($_SESSION['SONOS'][$id]['CurrentTrackData']['restricted'], $CurrentTrackMetaDataXml->item->attributes()->restricted);
							update($_SESSION['SONOS'][$id]['CurrentTrackData']['protocolInfo'], $CurrentTrackMetaDataXml->item->res->attributes()->protocolInfo);
							update($_SESSION['SONOS'][$id]['CurrentTrackData']['Duration'], $CurrentTrackMetaDataXml->item->res->attributes()->duration);
							update($_SESSION['SONOS'][$id]['CurrentTrackData']['URI'], $CurrentTrackMetaDataXml->item->res);
							update($_SESSION['SONOS'][$id]['CurrentTrackData']['streamContent'], $CurrentTrackMetaDataXml->item->children($CurrentNamespaces['r'])->streamContent);
							update($_SESSION['SONOS'][$id]['CurrentTrackData']['radioShowMd'], $CurrentTrackMetaDataXml->item->children($CurrentNamespaces['r'])->radioShowMd);
							update($_SESSION['SONOS'][$id]['CurrentTrackData']['albumArtURI'], rawurlencode($CurrentTrackMetaDataXml->item->children($CurrentNamespaces['upnp'])->albumArtURI));
							update($_SESSION['SONOS'][$id]['CurrentTrackData']['title'], $CurrentTrackMetaDataXml->item->children($CurrentNamespaces['dc'])->title);
							update($_SESSION['SONOS'][$id]['CurrentTrackData']['class'], $CurrentTrackMetaDataXml->item->children($CurrentNamespaces['upnp'])->class);
							update($_SESSION['SONOS'][$id]['CurrentTrackData']['creator'], $CurrentTrackMetaDataXml->item->children($CurrentNamespaces['dc'])->creator);
							update($_SESSION['SONOS'][$id]['CurrentTrackData']['album'], $CurrentTrackMetaDataXml->item->children($CurrentNamespaces['upnp'])->album);
							update($_SESSION['SONOS'][$id]['CurrentTrackData']['originalTrackNumber'], $CurrentTrackMetaDataXml->item->children($CurrentNamespaces['upnp'])->originalTrackNumber);
							update($_SESSION['SONOS'][$id]['CurrentTrackData']['albumArtist'], $CurrentTrackMetaDataXml->item->children($CurrentNamespaces['r'])->albumArtist);
						}
					}
				}
				
				$temp = $InstanceID->children($innerNamespaces['r'])->NextTrackMetaData->attributes()->val;
				if ( isset($temp) ){
					if($temp == ""){
						$_SESSION['SONOS'][$id]['NextTrackData'] = '';
					} else {
						$NextTrackMetaDataXml = simplexml_load_string((string)($temp));
						if(is_object($NextTrackMetaDataXml)){
							$NextNamespaces = $NextTrackMetaDataXml->getNameSpaces(true);
		
							if ($_SESSION['SONOS'][$id]['NextTrackData'] == null){$_SESSION['SONOS'][$id]['NextTrackData'] = array();}
							update($_SESSION['SONOS'][$id]['NextTrackData']['id'], $NextTrackMetaDataXml->item->attributes()->id);
							update($_SESSION['SONOS'][$id]['NextTrackData']['parentID'], $NextTrackMetaDataXml->item->attributes()->parentID);
							update($_SESSION['SONOS'][$id]['NextTrackData']['restricted'], $NextTrackMetaDataXml->item->attributes()->restricted);
							update($_SESSION['SONOS'][$id]['NextTrackData']['protocolInfo'], $NextTrackMetaDataXml->item->res->attributes()->protocolInfo);
							update($_SESSION['SONOS'][$id]['NextTrackData']['Duration'], $NextTrackMetaDataXml->item->res->attributes()->duration);
							update($_SESSION['SONOS'][$id]['NextTrackData']['URI'], $NextTrackMetaDataXml->item->res);
							update($_SESSION['SONOS'][$id]['NextTrackData']['streamContent'], $NextTrackMetaDataXml->item->children($NextNamespaces['r'])->streamContent);
							update($_SESSION['SONOS'][$id]['NextTrackData']['radioShowMd'], $NextTrackMetaDataXml->item->children($NextNamespaces['r'])->radioShowMd);
							update($_SESSION['SONOS'][$id]['NextTrackData']['albumArtURI'], rawurlencode($NextTrackMetaDataXml->item->children($NextNamespaces['upnp'])->albumArtURI));
							update($_SESSION['SONOS'][$id]['NextTrackData']['title'], $NextTrackMetaDataXml->item->children($NextNamespaces['dc'])->title);
							update($_SESSION['SONOS'][$id]['NextTrackData']['class'], $NextTrackMetaDataXml->item->children($NextNamespaces['upnp'])->class);
							update($_SESSION['SONOS'][$id]['NextTrackData']['creator'], $NextTrackMetaDataXml->item->children($NextNamespaces['dc'])->creator);
							update($_SESSION['SONOS'][$id]['NextTrackData']['album'], $NextTrackMetaDataXml->item->children($NextNamespaces['upnp'])->album);
							update($_SESSION['SONOS'][$id]['NextTrackData']['originalTrackNumber'], $NextTrackMetaDataXml->item->children($NextNamespaces['upnp'])->originalTrackNumber);
							update($_SESSION['SONOS'][$id]['NextTrackData']['albumArtist'], $NextTrackMetaDataXml->item->children($NextNamespaces['r'])->albumArtist);
						}
					}
				}
				
				
				if ($InstanceID->children($innerNamespaces['r'])->EnqueuedTransportURI) update($_SESSION['SONOS'][$id]['EnqueuedTransportURI'], $InstanceID->children($innerNamespaces['r'])->EnqueuedTransportURI->attributes()->val);
				
				$temp = $InstanceID->children($innerNamespaces['r'])->EnqueuedTransportURIMetaData->attributes()->val;
				if ( isset($temp) ){
					if($temp == ""){
						$_SESSION['SONOS'][$id]['EnqueuedTransportURItitle'] = '';
					} else {
						$EnqueuedTransportURIMetaDataXml = simplexml_load_string((string)($temp));
						if(is_object($EnqueuedTransportURIMetaDataXml)){
							$EnqueuedTransportNamespaces = $EnqueuedTransportURIMetaDataXml->getNameSpaces(true);
							update($_SESSION['SONOS'][$id]['EnqueuedTransportURItitle'], $EnqueuedTransportURIMetaDataXml->item->children($EnqueuedTransportNamespaces['dc'])->title);
						}
					}
				}
				
				if ($InstanceID->PlaybackStorageMedium) update($_SESSION['SONOS'][$id]['PlaybackStorageMedium'], $InstanceID->PlaybackStorageMedium->attributes()->val);
				if ($InstanceID->CurrentTransportActions) update($_SESSION['SONOS'][$id]['CurrentTransportActions'], $InstanceID->CurrentTransportActions->attributes()->val);
				if ($InstanceID->TransportStatus) update($_SESSION['SONOS'][$id]['TransportStatus'], $InstanceID->TransportStatus->attributes()->val);
				if ($InstanceID->children($innerNamespaces['r'])->SleepTimerGeneration) update($_SESSION['SONOS'][$id]['SleepTimerGeneration'], $InstanceID->children($innerNamespaces['r'])->SleepTimerGeneration->attributes()->val);
				if ($InstanceID->children($innerNamespaces['r'])->AlarmRunning) update($_SESSION['SONOS'][$id]['AlarmRunning'], $InstanceID->children($innerNamespaces['r'])->AlarmRunning->attributes()->val);
				if ($InstanceID->children($innerNamespaces['r'])->SnoozeRunning) update($_SESSION['SONOS'][$id]['SnoozeRunning'], $InstanceID->children($innerNamespaces['r'])->SnoozeRunning->attributes()->val);
				if ($InstanceID->children($innerNamespaces['r'])->RestartPending) update($_SESSION['SONOS'][$id]['RestartPending'], $InstanceID->children($innerNamespaces['r'])->RestartPending->attributes()->val);
				if ($InstanceID->PossiblePlaybackStorageMedia) update($_SESSION['SONOS'][$id]['PossiblePlaybackStorageMedia'], $InstanceID->PossiblePlaybackStorageMedia->attributes()->val);

			}
			break;
	
		default:
			deleteWorking == false;
			break;
	} 

	$_SESSION['SONOS']["LastGlobalUpdate"] = $currentDateTime;
	//if ($rawHeader['REQUEST_METHOD'] == 'NOTIFY') {
		$_SESSION['SONOS']["LastNotify"] = $currentDateTime;
	//}
	
	
	if (!headers_sent() && ($deleteWorking == true)){unlink($filename);}
	header('x', TRUE, 200);
	//header("HTTP/1.1 200 OK");
	
?>