<?php

class WeatherXmlFeedForecast {
	private $PartnerID = '';
	private $LicenceKey = '';
	private $City = '';
	public $CurrentConditions = array();
	public $DaysForecast = array();
	private $ImagePath = '';
	private $Url = '';
	
	function __construct ($Var_City, $Var_ImagePath, $Var_PartnerID, $Var_LicenceKey) {
		$this->City = $Var_City;
		$this->PartnerID = $Var_PartnerID;
		$this->LicenceKey = $Var_LicenceKey;
		$this->ImagePath = $Var_ImagePath;
		$this->Url = 'http://xoap.weather.com/weather/local/'.$this->City.'?cc=*&dayf=5&link=xoap&prod=xoap&par='.$this->PartnerID.'&key='.$this->LicenceKey;
		
		$xmlCity = simplexml_load_string(file_get_contents($this->Url));
		$this->CurrentConditions['CityName'] = (string)$xmlCity->loc->dnam;
		$this->CurrentConditions['SunRise'] = $this->TimeEngToDeu((string)$xmlCity->loc->sunr);
		$this->CurrentConditions['SunSet'] = $this->TimeEngToDeu((string)$xmlCity->loc->suns);
		$this->CurrentConditions['Temperature'] = ($xmlCity->cc->tmp == "N/A") ? "" :  ((string)round((($xmlCity->cc->tmp - 32)/9) * 5)).'&#176;C';
		$this->CurrentConditions['FeelsLikeTemperature'] = ($xmlCity->cc->flik == "N/A") ? "" :  ((string)round((($xmlCity->cc->flik - 32)/9) * 5)).'&#176;C';
		$this->CurrentConditions['Decription'] = (string)$xmlCity->cc->t;
		$this->CurrentConditions['Icon'] = $this->ImagePath."/".(string)$xmlCity->cc->icon.".png";

		$i = 0;
		foreach ($xmlCity->dayf->day as $day){
			$this->DaysForecast[$i] = array();
			$this->DaysForecast[$i]['Day'] = $this->DayEngToDeu((string)$day['t']);
			$this->DaysForecast[$i]['Date'] =  $this->DateEngToDeu((string)$day['dt']);
			$this->DaysForecast[$i]['Low'] = ($day->low == "N/A") ? "" : ((string)round((($day->low - 32)/9) * 5)).'&#176;C';
			$this->DaysForecast[$i]['Hi'] = ($day->hi == "N/A") ? "" : ((string)round((($day->hi - 32)/9) * 5)).'&#176;C';

			foreach ($day->part as $part){
				if ($part['p'] == 'd'){
					$this->DaysForecast[$i]['DayDecription'] = (string)$part->t;
					$this->DaysForecast[$i]['DayIcon'] = $this->ImagePath."/".(string)$part->icon.".png";
				}
				if ($part['p'] == 'n'){
					$this->DaysForecast[$i]['NightDecription'] = (string)$part->t;
					$this->DaysForecast[$i]['NightIcon'] = $this->ImagePath."/".(string)$part->icon.".png";
				}
			}
			$i++;
		} 
	}

	function getCurrentConditions() {
		return $this->CurrentConditions;
	}
	
	function getForecastConditions($var_day) {
		return $this->DaysForecast[$var_day];
	}
	
	function TimeEngToDeu($var_engTime){
		$Time24 = "";
		$TimeParts = explode(" ", $var_engTime);
		$TimePartsHours = explode(":", $TimeParts[0]);
		$Time24 = (string)$TimeParts[0];
		if ($TimeParts[1] == "PM"){
			$Time24 = ((string)(((int)$TimePartsHours[0])+12)).":".(string)$TimePartsHours[1];
		}
		return $Time24;
	}

	function DateEngToDeu($var_engDate){
		$Dates = array("Jan" => "Januar", 
					   "Feb" => "Februar", 
				 	   "Mar" => "M&auml;rz", 
				 	   "Apr" => "April", 
				 	   "May" => "Mai", 
					   "Jun" => "Juni", 
					   "Jul" => "Juli", 
					   "Aug" => "August", 
					   "Sep" => "September", 
					   "Okt" => "Oktober", 
					   "Nov" => "November", 
					   "Dez" => "Dezember");
		
		$DateParts = explode(" ", $var_engDate);
		
		if (array_key_exists($DateParts[0], $Dates)){
			return $DateParts[1].". ".$Dates[$DateParts[0]];
		} else {
			return $DateParts[1].". ".$DateParts[0];
		}
	}

	function DayEngToDeu($var_engDay){
		$deuDay = "";
		
		$Days = array("Monday" => "Montag", 
					  "Tuesday" => "Dienstag", 
				 	  "Wednesday" => "Mittwoch", 
				 	  "Thursday" => "Donnerstag", 
				 	  "Friday" => "Freitag", 
					  "Saturday" => "Samstag", 
					  "Sunday" => "Sonntag");
		
		$deuDay = $Days[$var_engDay];
		return $deuDay;
	}
}

class WeatherXmlFileFeedForecast {
	public $CurrentConditions = array();
	public $DaysForecast = array();
	private $ImagePath = '';
	private $Var_FilePath = '';
	
	function __construct ($Var_FilePath, $Var_ImagePath) {
		$this->ImagePath = $Var_ImagePath;
		$this->Var_FilePath = $Var_FilePath;
			
		$xmlCity = simplexml_load_string(file_get_contents($this->Var_FilePath));
		$this->CurrentConditions['CityName'] = (string)$xmlCity->loc->dnam;
		$this->CurrentConditions['SunRise'] = $this->TimeEngToDeu((string)$xmlCity->loc->sunr);
		$this->CurrentConditions['SunSet'] = $this->TimeEngToDeu((string)$xmlCity->loc->suns);
		$this->CurrentConditions['Temperature'] = ($xmlCity->cc->tmp == "N/A") ? "" :  ((string)round((($xmlCity->cc->tmp - 32)/9) * 5)).'&#176;C';
		$this->CurrentConditions['FeelsLikeTemperature'] = ($xmlCity->cc->flik == "N/A") ? "" :  ((string)round((($xmlCity->cc->flik - 32)/9) * 5)).'&#176;C';
		$this->CurrentConditions['Decription'] = (string)$xmlCity->cc->t;
		$this->CurrentConditions['Icon'] = $this->ImagePath."/".(string)$xmlCity->cc->icon.".png";

		$i = 0;
		foreach ($xmlCity->dayf->day as $day){
			$this->DaysForecast[$i] = array();
			$this->DaysForecast[$i]['Day'] = $this->DayEngToDeu((string)$day['t']);
			$this->DaysForecast[$i]['Date'] =  $this->DateEngToDeu((string)$day['dt']);
			$this->DaysForecast[$i]['SunRise'] = $this->TimeEngToDeu((string)$day->sunr);
			$this->DaysForecast[$i]['SunSet'] = $this->TimeEngToDeu((string)$day->suns);
			$this->DaysForecast[$i]['Low'] = ($day->low == "N/A") ? "" : ((string)round((($day->low - 32)/9) * 5)).'&#176;C';
			$this->DaysForecast[$i]['Hi'] = ($day->hi == "N/A") ? "" : ((string)round((($day->hi - 32)/9) * 5)).'&#176;C';

			foreach ($day->part as $part){
				if ($part['p'] == 'd'){
					$this->DaysForecast[$i]['DayDecription'] = (string)$part->t;
					$this->DaysForecast[$i]['DayIcon'] = $this->ImagePath."/".(string)$part->icon.".png";
				}
				if ($part['p'] == 'n'){
					$this->DaysForecast[$i]['NightDecription'] = (string)$part->t;
					$this->DaysForecast[$i]['NightIcon'] = $this->ImagePath."/".(string)$part->icon.".png";
				}
			}
			$i++;
		} 
	}

	function getCurrentConditions() {
		return $this->CurrentConditions;
	}
	
	function getForecastConditions($var_day) {
		return $this->DaysForecast[$var_day];
	}
	
	function TimeEngToDeu($var_engTime){
		$Time24 = "";
		$TimeParts = explode(" ", $var_engTime);
		$TimePartsHours = explode(":", $TimeParts[0]);
		$Time24 = (string)$TimeParts[0];
		if ($TimeParts[1] == "PM"){
			$Time24 = ((string)(((int)$TimePartsHours[0])+12)).":".(string)$TimePartsHours[1];
		}
		return $Time24;
	}


	function DateEngToDeu($var_engDate){
		$Dates = array("Jan" => "Januar", 
					   "Feb" => "Februar", 
				 	   "Mar" => "M&auml;rz", 
				 	   "Apr" => "April", 
				 	   "May" => "Mai", 
					   "Jun" => "Juni", 
					   "Jul" => "Juli", 
					   "Aug" => "August", 
					   "Sep" => "September", 
					   "Okt" => "Oktober", 
					   "Nov" => "November", 
					   "Dez" => "Dezember");
		
		$DateParts = explode(" ", $var_engDate);
		
		if (array_key_exists($DateParts[0], $Dates)){
			return $DateParts[1].". ".$Dates[$DateParts[0]];
		} else {
			return $DateParts[1].". ".$DateParts[0];
		}
	}

	function DayEngToDeu($var_engDay){
		$deuDay = "";
		
		$Days = array("Monday" => "Montag", 
					  "Tuesday" => "Dienstag", 
				 	  "Wednesday" => "Mittwoch", 
				 	  "Thursday" => "Donnerstag", 
				 	  "Friday" => "Freitag", 
					  "Saturday" => "Samstag", 
					  "Sunday" => "Sonntag");
		
		$deuDay = $Days[$var_engDay];
		return $deuDay;
	}
}
?>