<?php
	include("xmlrpc.inc");
	include("xmlrpcs.inc");
	include("xmlrpc_wrappers.inc");
	require_once("../globals.inc.php");

	function sanitize($string = '', $is_filename = FALSE){
		// Replace all weird characters with dashes
		$string = preg_replace('/[^\w\-'. ($is_filename ? '~_\.' : ''). ']+/u', '-', $string);
		
		// Only allow one dash separator at a time (and make string lowercase)
		return mb_strtolower(preg_replace('/--+/u', '-', $string), 'UTF-8');
	}


	function foo ($xmlrpcmsg) {
		$inhalt = date("M-j G:i:s").":";
		$MsgParamScalars = array();
		$MsgNumParams = $xmlrpcmsg->getNumParams();
		
		for ($i = 0; $i < $MsgNumParams; $i++){
			$Param = $xmlrpcmsg->getParam($i);
			$MsgParamScalars[$i] = (string)($Param->scalarval());
			if ((strlen($MsgParamScalars[$i]) == 32) && ($i == 0)){
				continue;
			}

			$inhalt .= " ".$MsgParamScalars[$i].";";
		}

		$inhalt .= "\n";
		$handle  = fopen("log.txt", "a");
		fwrite ($handle, $inhalt);
		fclose ($handle);
	
		return new xmlrpcresp(new xmlrpcval("", "string"));
	}	
	
	function output ($xmlrpcmsg) {

		$inhalt = date("M-j G:i:s").":\n".$xmlrpcmsg->serialize()."\n\n";
		$handle  = fopen("log.txt", "a");
		fwrite ($handle, $inhalt);
		fclose ($handle);
	
		return new xmlrpcresp(new xmlrpcval("", "string"));
	}	
	
	function blank ($xmlrpcmsg) {

	
		return new xmlrpcresp(new xmlrpcval("", "string"));
	}	
	
	function homematic_xmlrpc_event ($xmlrpcmsg) {
		$MsgParamScalars = array();
		
		//$currentDateTime = date("M-d G:i:s");
		$currentDateTime = date(DATE_TIME_STRING);
		
		$MsgNumParams = $xmlrpcmsg->getNumParams();
		
		for ($i = 0; $i < $MsgNumParams; $i++){
			$Param = $xmlrpcmsg->getParam($i);
			if ($Param->kindOf() == "scalar"){
				if($Param->scalarTyp() == "boolean"){
					if ($Param->scalarVal() == true){
						$MsgParamScalars[$i] = "true";
					} else if ($Param->scalarVal() == false){
						$MsgParamScalars[$i] = "false";
					}
					
				} else {
					$MsgParamScalars[$i] = (string)($Param->scalarVal());
				}
				
			} else if ($Param->kindOf() == "array"){
//				for ($j = 0; $i < $Param->arraySize(); $j++)
//				{
//					// each arrayElement.kindOf() can be again "struct", "array" or "scalar"
//					//$arrayElement = $Param->arrayMem($j);
//				}
				
			} else if ($Param->kindOf() == "struct"){
//				$Param->structreset();
//				while (list($structElementKey, $structElementValue) = $Param->structEach())
//				{
//					// each structElementValue.kindOf() can be again "struct", "array" or "scalar"
//					//echo($structElementKey.":".$structElementValue);
//				}			
			}
		}
		
		if (strlen($MsgParamScalars[0]) == 32){
			session_id($MsgParamScalars[0]);
			session_start();
			
			$ParamDevice = (string)$MsgParamScalars[1];
			$ParamWhat = (string)$MsgParamScalars[2];
			$ParamValue = (string)$MsgParamScalars[3];
			
			$_SESSION['HOMEMATIC'][$ParamDevice][$ParamWhat] = $ParamValue;
			$_SESSION['HOMEMATIC'][$ParamDevice]["LastUpdate"] = $currentDateTime;
			$_SESSION['HOMEMATIC']["LastGlobalUpdate"] = $currentDateTime;
			
			// nach der ersten zutreffenden Regel wird abgebrochen
			// regeln als Regular Expressions
			$ruleMatched = false;
			foreach ($GLOBALS['historyRules'] as $rule){
				if(($ruleMatched == false) && preg_match($rule["DEVICE"], $ParamDevice) && preg_match($rule["DATAPOINT"], $ParamWhat) && preg_match($rule["VALUE"], $ParamValue)) {
					for ($i = $rule["HISTORY"]; $i >= 1; $i--) {
						if ($i > 1) {
							$_SESSION['HOMEMATIC'][$ParamDevice][$ParamWhat.'_HISTORY'][$i]['VALUE'] = $_SESSION['HOMEMATIC'][$ParamDevice][$ParamWhat.'_HISTORY'][$i-1]['VALUE'];
							$_SESSION['HOMEMATIC'][$ParamDevice][$ParamWhat.'_HISTORY'][$i]['TIME'] = $_SESSION['HOMEMATIC'][$ParamDevice][$ParamWhat.'_HISTORY'][$i-1]['TIME'];
						} else {
							$_SESSION['HOMEMATIC'][$ParamDevice][$ParamWhat.'_HISTORY'][1]['VALUE'] = $ParamValue;
							$_SESSION['HOMEMATIC'][$ParamDevice][$ParamWhat.'_HISTORY'][1]['TIME'] = $currentDateTime;
						}
					}
					$ruleMatched = true;
					if ($rule["LOG_TO_FILE"]){
						$inhalt = "$currentDateTime :".var_export($_SESSION['HOMEMATIC'][$ParamDevice], true)."\n";
						$handle  = fopen("log/".sanitize($ParamDevice, true).".txt", "a");
						fwrite ($handle, $inhalt);
						fclose ($handle);
					}
				}
			}
			
		}
		return new xmlrpcresp(new xmlrpcval("", "string"));
	}	

	$s = new xmlrpc_server(
		array(
			"listDevices" => array("function" => "blank"),
			"multiCall" => array("function" => "output"),
			"event" => array("function" => "homematic_xmlrpc_event"),
			"test" => array("function" => "homematic_xmlrpc_event"),
			"newDevice" => array("function" => "output")
		)
	);	
?>